#ifndef __Interrupt_context_h__
#define __Interrupt_context_h__

//**++
struct CPU_State
{
    // r13 und r14 des Usermodes
    unsigned int usr_r13, usr_r14;
    // CPSR vor dem IRQ und SPSR des Supervisormodes
    unsigned int cpsr, svc_spsr;
    // r13 und r14 des Supervisormodes
    unsigned int svc_r13, svc_r14;
    // r0 bis r12 sowie r15
    unsigned int r0, r1, r2, r3, r4, r5, r6, r7;
    unsigned int r8, r9, r10, r11, r12, r15;
} __attribute__((packed));

struct FPU_State
{
    // D Registers
    double d[32];
    // CPSR vor dem IRQ und SPSR des Supervisormodes
    unsigned int fpscr;
	unsigned int fpexc;    
} __attribute__((packed));
//**--

#endif //__Interrupt_context_h__