#ifndef __MemoryMap_h__
#define __MemoryMap_h__



#define MyT12


#ifndef MyT12
#error MyT12 nicht definiert
#endif


/*
	Speicher Zed:
	MPU				1fff0000 - 1fffffff 
	Code von		1ff96000 - 1ffe5400

	IRQ Stack 0		10004000 - 10006000		#wchst nach unten (kleinere Addressen)
	Stack 0			10002000 - 10004000
	IRQ Stack 1		10000000 - 10002000
	Stack 1					 - 10000000

	k_Rx_Buffers		02830000 - 02840000
	k_My_Tx_Buffer	02820000 - 02830000
	TX_BD			02810000 - 02820000	
	RX_BD			02800000 - 02810000
	
*/

#if defined(MyXilinx)

#define k_Generated_Glb_Data_Size (0) // (sizeof(struct global_data) + 15) & ~15 hier auf 0 gesetzt, da nicht angelegt


//**++
#define k_Config_Sys_SDRAM_Base		0x4000
//#error  TESTHILFE
//**--

#if defined(MyZed)
#define k_Config_Sys_SDRAM_Size		0x20000000
#else
#if defined(MyT12)
#define k_Config_Sys_SDRAM_Size		0x40000000
#else
#define k_Config_Sys_SDRAM_Size		0x40000000
#endif
#endif


#define k_Config_Sys_Init_RAM_Addr	0xFFFF0000
#define k_Config_Sys_Init_RAM_Size	0x1000
#define k_Config_Sys_Init_SP_Addr		(k_Config_Sys_Init_RAM_Addr + \
					k_Config_Sys_Init_RAM_Size - \
					k_Generated_Glb_Data_Size)

#define k_Rx_Bd_Start_Addr	0x02800000
#define k_Tx_Bd_Start_Addr	0x02810000
#define k_My_Tx_Buffer		0x02820000
#define k_Rx_Buffers			0x02830000		// Lnge 0x3200

#endif

#ifdef MyPanda

/* SDRAM Memory Map
 * Even though we use two CS all the memory
 * is mapped to one contiguous block
 */
//#define CONFIG_NR_DRAM_BANKS	1

#define k_Generated_Glb_Data_Size (0) /* (sizeof(struct global_data) + 15) & ~15 hier auf 0 gesetzt, da nicht angelegt*/

#define k_Config_Sys_SDRAM_Base		0x80000000
#define k_Config_Sys_SDRAM_Size		0x40000000
#define k_Config_Sys_Init_RAM_Addr	0x4030D800
#define k_Config_Sys_Init_RAM_Size	0x800
#define k_Config_Sys_Init_SP_Addr		(k_Config_Sys_Init_RAM_Addr + \
					 k_Config_Sys_Init_RAM_Size - \
					 GENERATED_GBL_DATA_SIZE)


#endif

//#define k_My_Mem_End_Loc	(CONFIG_SYS_SDRAM_BASE + k_Config_Sys_SDRAM_Size - 0x10000000)
#define k_My_Mem_End_Loc	(k_Config_Sys_SDRAM_Size - 0x10000000)
//**++

#define k_MemoryMap_Vars_Start				(0x00100000)
#define k_MemoryMap_Global_Ptr				(0x00102000)
//**--
#define k_MemoryMap_Spinlocks				(0x00102080)
#define k_MemoryMap_Vars2_Start				(0x00102200)
//#define k_MemoryMap_Spinlocks				(k_Config_Sys_SDRAM_Base+0x02100000)

//#define k_MemoryMap_Malloc_Cache				(k_Config_Sys_SDRAM_Base+0x04000000)
#define k_MemoryMap_Malloc_Cache			(0x00103000)

//#define k_MemoryMap_Malloc_Uncache			(k_Config_Sys_SDRAM_Base+0x08000000)
//#define k_MemoryMap_Malloc_Uncache			(0x00500000)		// gibt Probleme zwichen 0x60000 - 0x70000 zwichen den Cores ???
//#define k_MemoryMap_Malloc_Uncache			(0x00700000)		// gibt Probleme zwichen 0x60000 - 0x70000 zwichen den Cores ???
#define k_MemoryMap_Malloc_Uncache			(0x01100000)
#define k_MemoryMap_Malloc_End				(0x3FC00000)
//#define k_MemoryMap_Malloc_End				(k_My_Mem_End_Loc-    0x02000000)

#define k_MemoryMap_Stackpointer_CPU1		(0x3FC18000)	//ok
#define k_MemoryMap_Int_Stack_CPU1			(0x3FD00000)	//ok
#define k_MemoryMap_Int_Stackpointer_CPU0	(0x3FD80000)  // ok
#define k_MemoryMap_Int_Stack_CPU0			(0x3FE00000)
//#define k_MemoryMap_Comm_Stack_CPU1			(0x3F480000)
#define k_MemoryMap_Fiq_Stack_CPU0			(0x3FE80000)
#define k_MemoryMap_Fiq_Stack_CPU1			(0x3FF00000)

/*#define k_MemoryMap_Stackpointer_CPU1		(k_My_Mem_End_Loc+0x00218000)	//ok
#define k_MemoryMap_Int_Stack_CPU1			(k_My_Mem_End_Loc+0x00300000)	//ok
#define k_MemoryMap_Int_Stackpointer_CPU0	(k_My_Mem_End_Loc+0x00380000)  // ok
#define k_MemoryMap_Int_Stack_CPU0			(k_My_Mem_End_Loc+0x00400000)
#define k_MemoryMap_Comm_Stack_CPU1			(k_My_Mem_End_Loc+0x00480000)
#define k_MemoryMap_Fiq_Stack_CPU0			(k_My_Mem_End_Loc+0x00500000)
#define k_MemoryMap_Fiq_Stack_CPU1			(k_My_Mem_End_Loc+0x00580000)*/

#define k_MemoryMap_Page_Table				(k_My_Mem_End_Loc+0x0fff0000)
#endif// __MemoryMap_h__