'<ADbasic Header, Headerversion 001.001>
' Foldings                       = 43,83,140,162,207,239,327,352,386,420,464,495,529,563,588,616,641,688,713,782,851,880,894,913,922,927,952,956,991,1035,1117,1166,1206,1246,1289,1338,1387,1434,1484,1524,1564,1601,1638,1681,1721,1774,1795
' Foldings                       = 1800,1818
'<Header End>
'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--INC--PRO
'
'###############################################################
'#                        EEPROM_Support.inc                   #
'#              INCLUDE-file for ADwin Systems with            #
'#            Bootloader option and Ethernet connection        #
'###############################################################
'#                                                             #
'# Contents: Access instructions for reading and writing to    #
'#           the permanent storage (Flash and EEPROM) of the   #
'#           ethernet interface. Instructions to access a      #
'#           Simatic PLC.                                      #
'#                                                             #
'#  02.08.2008  TB  creation                                   #
'#  12.07.2010  MB  error-code fix                             #
'#  12.11.2010  GC  added documentation; flash and polling     #
'#                  instructions hidden                        #
'#  07.12.2010  TN  saved because of missing 0D0A              #
'#                  at end of line                             #
'#  06.06.2011  TB  Bugfix in timeout handling                 #
'#  27.06.2012  MS  Bugfix Send_IRQs hinzugefgt               #
'#  22.01.2013  TH  ENet3/S-ATA/USB-Support                    #
'#  11.02.2013  TH  ENet3/S-ATA/USB-Support Enhancements       #
'#                  NFS-Support, Status functions              #
'#  12.03.2013  TH  Bugfix File_Stat                           #
'#  10.04.2013  TH  Various enhancements for ENet3/S-ATA/USB-  #
'#                  Support                                    #
'#   1.04.2014  TH  added support for Localtime, Error_Text    #
'#                  minor bugfixes                             #
'#  12.05.2014  MF  T12 Beta Support                           #
'#  07.10.2014  TN  Send_IRQ for T12 -> nop                    #
'#  03.12.2014  JK  see: "compiler_optimisation"               #
'#                                                             #
'#                                                             #
'# Attention:                                                  #
'#   - Do not copy the first source line (containing           #
'#     "'ADBASIC-SYSTEM-FILE...") to user files !              #
'#     Otherwise the Syntax color may be not correct.          #
'#   - This includefile requires ADbasic 4.20.04 or higher!    #
'#                                                             #
'###############################################################

'<REGION> ' Commands written to Par_95
#Define EEPROM_SUPPORT_EEPROM_READ                 1        '<HIDE>
#Define EEPROM_SUPPORT_EEPROM_WRITE                2        '<HIDE>
#Define EEPROM_SUPPORT_GET_FIRMWARE_VERSION        3        '<HIDE>
#Define EEPROM_SUPPORT_FLASH_READ                  4        '<HIDE>
#Define EEPROM_SUPPORT_FLASH_WRITE                 5        '<HIDE>
#Define EEPROM_SUPPORT_GET_FLASH_SIZE              6        '<HIDE>
#Define EEPROM_SUPPORT_SET_FLASH_SIZE              7        '<HIDE>
#Define EEPROM_SUPPORT_SFW_CONNECT                10        '<HIDE>
#Define EEPROM_SUPPORT_SFW_CLOSE                  11        '<HIDE>
#Define EEPROM_SUPPORT_SFW_FETCH                  12        '<HIDE>
#Define EEPROM_SUPPORT_SFW_WRITE                  13        '<HIDE>
#Define EEPROM_SUPPORT_SFW_SET_POLLING_DELAY      14        '<HIDE>
#Define EEPROM_SUPPORT_EEPROM_SET_ERROR_TEXT_DATA 50        '<HIDE>
#Define EEPROM_SUPPORT_EEPROM_GET_LOCALTIME       60        '<HIDE>
#Define EEPROM_SUPPORT_GET_FREE_FLASH_SPACE      100        '<HIDE>
#Define EEPROM_SUPPORT_STORAGE_CREATE_PARTITIONS   1000     '<HIDE>
#Define EEPROM_SUPPORT_STORAGE_FORMAT              1001     '<HIDE>
#Define EEPROM_SUPPORT_STORAGE_MOUNT               1002     '<HIDE>
#Define EEPROM_SUPPORT_STORAGE_UNMOUNT             1003     '<HIDE>
#Define EEPROM_SUPPORT_STORAGE_FS_STAT             1004     '<HIDE>
'#Define EEPROM_SUPPORT_STORAGE_SMART               1005        '<HIDE>
#Define EEPROM_SUPPORT_STORAGE_FILE_CREATE         1100     '<HIDE>
#Define EEPROM_SUPPORT_STORAGE_FILE_DELETE         1101     '<HIDE>
#Define EEPROM_SUPPORT_STORAGE_FILE_EXISTS         1102     '<HIDE>
#Define EEPROM_SUPPORT_STORAGE_FILE_WRITE          1103     '<HIDE>
#Define EEPROM_SUPPORT_STORAGE_FILE_READ           1104     '<HIDE>
#Define EEPROM_SUPPORT_STORAGE_FILE_APPEND         1105     '<HIDE>
#Define EEPROM_SUPPORT_STORAGE_FILE_STAT           1106     '<HIDE>
#Define EEPROM_SUPPORT_STORAGE_FILE_MOVE           1107     '<HIDE>
#Define EEPROM_SUPPORT_STORAGE_FILE_COPY           1108     '<HIDE>
#Define EEPROM_SUPPORT_STORAGE_DIR_CREATE          1200     '<HIDE>
#Define EEPROM_SUPPORT_STORAGE_DIR_DELETE          1201     '<HIDE>
#Define EEPROM_SUPPORT_STORAGE_DIR_EXISTS          1202     '<HIDE>
#Define EEPROM_SUPPORT_STORAGE_DIR_STAT            1203     '<HIDE>
#Define EEPROM_SUPPORT_STORAGE_DIR_SIZE            1204     '<HIDE>
#Define EEPROM_SUPPORT_STORAGE_MAX_INSTRUCTION     2000     '<HIDE>

'<ENDREGION>

'<REGION> ' Response codes from Par_95
''' No error, command completed successfully
#Define EEPROM_SUPPORT_OK                                      0
' General error codes
#Define EEPROM_SUPPORT_ERROR_UNKNOWN_COMMAND                  -1
' EEPROM/Flash Error code
#Define EEPROM_SUPPORT_ERROR_INVALID_POSITION                 -2
#Define EEPROM_SUPPORT_ERROR_INVALID_COUNT                    -3
#Define EEPROM_SUPPORT_ERROR_INVALID_COUNT_AND_POSITION       -4
#Define EEPROM_SUPPORT_ERROR_DATA_200_ACCESS_ERROR            -5
#Define EEPROM_SUPPORT_ERROR_DATA_ACCESS_ERROR                -6
#Define EEPROM_SUPPORT_ERROR_EEPROM_READ_ERROR                -7
#Define EEPROM_SUPPORT_ERROR_EEPROM_WRITE_ERROR               -8
#Define EEPROM_SUPPORT_ERROR_FLASH_ALLOC                     -10  '<HIDE>
#Define EEPROM_SUPPORT_ERROR_FLASH_ACCESS                    -11  '<HIDE>
#define EEPROM_SUPPORT_ERROR_RTC                             -60
#Define EEPROM_SUPPORT_ERROR_TIMEOUT                        -100
''' Previous command is not yet completed.
#Define EEPROM_SUPPORT_ERROR_NOT_READY                      -101
' Simatic Errors
#Define EEPROM_SUPPORT_ERROR_DATA_199_ACCESS_ERROR         -1010
#Define EEPROM_SUPPORT_ERROR_CANNOT_CONNECT                -1011
#Define EEPROM_SUPPORT_ERROR_NOT_CONNECTED                 -1012
#Define EEPROM_SUPPORT_ERROR_MISSING_ACK_FETCH             -1013
#Define EEPROM_SUPPORT_ERROR_ACK_ERROR_FETCH               -1014
#Define EEPROM_SUPPORT_ERROR_RECEIVE_ERROR                 -1015
#Define EEPROM_SUPPORT_ERROR_FETCH_DATA_ACCESS_ERROR       -1016
#Define EEPROM_SUPPORT_ERROR_MISSING_ACK_WRITE             -1017
#Define EEPROM_SUPPORT_ERROR_ACK_ERROR_WRITE               -1018
#Define EEPROM_SUPPORT_ERROR_WRITE_ERROR                   -1019
#Define EEPROM_SUPPORT_ERROR_WRITE_DATA_ACCESS_ERROR       -1020
#Define EEPROM_SUPPORT_ERROR_INVALID_POLLING_DELAY         -1021  '<HIDE>
#Define EEPROM_SUPPORT_ERROR_INVALID_DATA_NUMBER           -1022
#Define EEPROM_SUPPORT_ERROR_INVALID_MEMORY_TYPE           -1023
#Define EEPROM_SUPPORT_ERROR_INVALID_MEMORY_BLOCK_NUMBER   -1024
#Define EEPROM_SUPPORT_ERROR_INVALID_START_ADDRESS         -1025
#Define EEPROM_SUPPORT_ERROR_INVALID_PORT_NUMBER           -1027
#Define EEPROM_SUPPORT_ERROR_INVALID_TIMEOUT               -1028
#define EEPROM_SUPPORT_ERROR_STORAGE_GENERAL_ERROR               -100000
#define EEPROM_SUPPORT_ERROR_STORAGE_INVALID_DEVICE_ID           -100001
#define EEPROM_SUPPORT_ERROR_STORAGE_NO_SUCH_FILE_OR_DIRECTORY   -100002
#define EEPROM_SUPPORT_ERROR_STORAGE_ERROR_WRITING_TO_DISK       -100003
#define EEPROM_SUPPORT_ERROR_STORAGE_ERROR_READING_FROM_DISK     -100004
#define EEPROM_SUPPORT_ERROR_STORAGE_ERROR_COULD_NOT_DELETE_FILE -100005
#define EEPROM_SUPPORT_ERROR_STORAGE_NOT_MOUNTED                 -100006
#define EEPROM_SUPPORT_ERROR_STORAGE_ALREADY_MOUNTED             -100007
#define EEPROM_SUPPORT_ERROR_STORAGE_ERROR_RENAMING_FILE         -100008
#define EEPROM_SUPPORT_ERROR_STORAGE_COULD_NOT_CREATE_FILE       -100009
#define EEPROM_SUPPORT_ERROR_STORAGE_COULD_NOT_DELETE_FILE       -100010
#define EEPROM_SUPPORT_ERROR_STORAGE_INVALID_FILESYSTEM_ID       -100011
#define EEPROM_SUPPORT_ERROR_STORAGE_ADWIN_COMMUNICATION_ERROR   -500000

' ToDo: fix
' -100 - -199: SPS liefert einen Fehler (abzglich -100) im ACK beim Fetch
' -200 - -299: SPS liefert einen Fehler (abzglich -200) im ACK beim Write
'<ENDREGION>

'<REGION> ' structure of main communication data
Dim Data_200[15] As Long
#Define EEPROM_SUPPORT_START_INDEX    1                     '<HIDE>
#Define EEPROM_SUPPORT_COUNT          2                     '<HIDE>
#Define EEPROM_SUPPORT_DATA_NO        3                     '<HIDE> 
#Define EEPROM_SUPPORT_RESULT         4                     '<HIDE> 
#Define EEPROM_SUPPORT_RESERVED       5                     '<HIDE>
#Define EEPROM_SUPPORT_LAST_COMMAND   6                     '<HIDE>
' For SATA, USB and ENET3-Flash the following defines are used:
#Define EEPROM_SUPPORT_D200_STORAGE_DEVICE        1         '<HIDE>
#Define EEPROM_SUPPORT_D200_STORAGE_PARTITION     2         '<HIDE>
#Define EEPROM_SUPPORT_D200_STORAGE_FILENAME      3         '<HIDE> 
#Define EEPROM_SUPPORT_D200_STORAGE_RESULT        4         '<HIDE> 
#Define EEPROM_SUPPORT_D200_STORAGE_INFOS         5         '<HIDE>
#Define EEPROM_SUPPORT_D200_STORAGE_LAST_COMMAND  6         '<HIDE>
#Define EEPROM_SUPPORT_D200_STORAGE_FILE_OFFSET   7         '<HIDE> 
#Define EEPROM_SUPPORT_D200_STORAGE_DATA_NO       8         '<HIDE> 
#Define EEPROM_SUPPORT_D200_STORAGE_DATA_OFFSET   9         '<HIDE> 
#Define EEPROM_SUPPORT_D200_STORAGE_BYTECOUNT    10         '<HIDE> 
#Define EEPROM_SUPPORT_D200_STORAGE_ERROR_DETAIL 11         '<HIDE>
'<ENDREGION>

'<REGION> ' structure of Simatic control data
Dim Data_199[20] As Long
#Define EEPROM_SUPPORT_D199_DATA_NUMBER_FETCH           1   '<HIDE>
#Define EEPROM_SUPPORT_D199_DATA_NUMBER_WRITE           2   '<HIDE>
#Define EEPROM_SUPPORT_D199_COUNT_FETCH                 3   '<HIDE>
#Define EEPROM_SUPPORT_D199_COUNT_WRITE                 4   '<HIDE>
#Define EEPROM_SUPPORT_D199_START_ADDRESS_FETCH         5   '<HIDE>
#Define EEPROM_SUPPORT_D199_START_ADDRESS_WRITE         6   '<HIDE>
#Define EEPROM_SUPPORT_D199_IP_ADDRESS                  7   '<HIDE>
#Define EEPROM_SUPPORT_D199_PORT_NUMBER_FETCH           8   '<HIDE>
#Define EEPROM_SUPPORT_D199_PORT_NUMBER_WRITE           9   '<HIDE>
#Define EEPROM_SUPPORT_D199_MEMORY_BLOCK_NUMBER_FETCH  10   '<HIDE>
#Define EEPROM_SUPPORT_D199_MEMORY_BLOCK_NUMBER_WRITE  11   '<HIDE>
#Define EEPROM_SUPPORT_D199_MEMORY_TYPE_FETCH          12   '<HIDE>
#Define EEPROM_SUPPORT_D199_MEMORY_TYPE_WRITE          13   '<HIDE>
#Define EEPROM_SUPPORT_D199_TCP_TIMEOUT                14   '<HIDE>
#Define EEPROM_SUPPORT_D199_POLLING_DELAY              15   '<HIDE>

#Define SIMATIC_MEMORY_TYPE_DB                          1
#Define SIMATIC_MEMORY_TYPE_M                           2
#Define SIMATIC_MEMORY_TYPE_E                           3
#Define SIMATIC_MEMORY_TYPE_A                           4
#Define SIMATIC_MEMORY_TYPE_PE_PA                       5
#Define SIMATIC_MEMORY_TYPE_Z                           6
#Define SIMATIC_MEMORY_TYPE_T                           7
'<ENDREGION>

'<REGION> ' SEND_IRQ
#IF ADWIN_SYSTEM = ADWIN_PROII THEN
#if prozessor = t11
#define SEND_IRQ Poke(10000810h, 1)                         '<HIDE>
#endif
#if prozessor = t12
#define SEND_IRQ nop                                        '<HIDE>
#endif
#ELSE
#IF ADWIN_SYSTEM = ADWIN_GOLDII THEN
#define SEND_IRQ Poke(0c000260h, 1)                         '<HIDE>
#ELSE
' no poke support for Light or Pro I
#define SEND_IRQ nop                                        '<HIDE>
#ENDIF
#ENDIF
'<ENDREGION>

'<REGION> ' Processor dependent timing information
#If PROCESSOR = T9

#Define TIMER_TICK_LENGTH_HIGH    25                        '<HIDE>
#Define TIMER_TICK_LENGTH_LOW 100000                        '<HIDE>

#Else
#If PROCESSOR = T10

#Define TIMER_TICK_LENGTH_HIGH    25                        '<HIDE>
#Define TIMER_TICK_LENGTH_LOW  50000                        '<HIDE>

#Else
#If PROCESSOR = T11

#Define TIMER_TICK_LENGTH_HIGH 3.33333333333                '<HIDE>
#Define TIMER_TICK_LENGTH_LOW  3.33333333333                '<HIDE>

#Else
#If PROCESSOR = T12
#Define TIMER_TICK_LENGTH_HIGH 1                            '<HIDE>
#Define TIMER_TICK_LENGTH_LOW  1                            '<HIDE>
#else

#Error "Undefined Processor"

#endif
#EndIf
#EndIf
#EndIf
'<ENDREGION>

'<REGION> Helper functions
'****************************************************************************
''' Returns the time since the previous command in milliseconds.
'''+Required to detect timeout while polling.
'''+Note that this function only works withing the overflow range of the timer
'''****************************************************************************
Function EEPROM_Timer_Diff_ms(start, stop) As Float         '<HIDE>
  Dim Tmp As Integer
  ' this step is necessary, because otherwise float subtraction is used and overflow problems occur.
  Tmp = Stop - Start                                        
#If PRIORITAET = HIGH
  EEPROM_Timer_Diff_ms = (Tmp) / 1000000 * TIMER_TICK_LENGTH_HIGH
#Else
  EEPROM_Timer_Diff_ms = (Tmp) / 1000000 * TIMER_TICK_LENGTH_LOW
#EndIf
EndFunction

'****************************************************************************
''' Waits for the result of the previous command and returns the
'''+appropriate return value.
'''****************************************************************************
Function EEPROM_Poll_Result(command) As Long                '<HIDE>
  Dim StartTime, CurrentTime, Timeout, TimeDiff as Long
  
  SelectCase command
    Case EEPROM_SUPPORT_GET_FIRMWARE_VERSION
    CCase EEPROM_SUPPORT_GET_FLASH_SIZE
    CCase EEPROM_SUPPORT_GET_FREE_FLASH_SPACE
    CCase EEPROM_SUPPORT_EEPROM_READ
    CCase EEPROM_SUPPORT_FLASH_READ
    CCase EEPROM_SUPPORT_EEPROM_WRITE
      Timeout = 20000                                       ' 20s
    Case EEPROM_SUPPORT_FLASH_WRITE, EEPROM_SUPPORT_SET_FLASH_SIZE
      Timeout = 500000                                      ' 500s
  EndSelect
  
  ' "compiler_optimisation"     (by JK: 03.12.2014)
  ' original code:
  '  If ((command >= EEPROM_SUPPORT_STORAGE_CREATE_PARTITIONS) and (command < EEPROM_SUPPORT_STORAGE_MAX_INSTRUCTION)) Then 
  '   Timeout = 500000                                        ' 500s
  '  EndIf
  ' optimized code:
  If (command >= EEPROM_SUPPORT_STORAGE_CREATE_PARTITIONS) then
    if (command < EEPROM_SUPPORT_STORAGE_MAX_INSTRUCTION) Then 
      Timeout = 500000                                        ' 500s
    EndIf
  EndIf
      
  StartTime = Read_Timer()
  ' poll for up to 100ms - if there was no response after 100ms EEPROM support 
  ' is probably not available or not enabled
  Do
    ' busy loop
    CurrentTime = Read_Timer()
    TimeDiff = EEPROM_Timer_Diff_ms(StartTime, CurrentTime)
    If (TimeDiff > 100) Then
      Timeout = Timeout - TimeDiff
      StartTime = Read_Timer()
    EndIf
    SEND_IRQ
  Until ((Timeout < 0) Or (Par_95 <> COMMAND))
  
  If (Par_95 <> COMMAND) Then
    ' for the commands Get_Flash_Size and Get_Free_Flash_Space the returned value is in Data_200, which we want to hide from the user
    If (((Data_200[EEPROM_SUPPORT_LAST_COMMAND] = EEPROM_SUPPORT_GET_FLASH_SIZE) Or (Data_200[EEPROM_SUPPORT_LAST_COMMAND] = EEPROM_SUPPORT_GET_FREE_FLASH_SPACE)) And (Par_95 = 0)) Then
      EEPROM_Poll_Result = Data_200[EEPROM_SUPPORT_RESULT]
      ' some simatic error codes clashed with flash error codes, so move all pure simatic errors by -1000
    Else : If ((((Data_200[EEPROM_SUPPORT_LAST_COMMAND] >= EEPROM_SUPPORT_SFW_CONNECT) And (Data_200[EEPROM_SUPPORT_LAST_COMMAND] <= EEPROM_SUPPORT_SFW_SET_POLLING_DELAY)) And (Par_95 < -8)) And (Par_95 > -1000)) Then
      ' offset for Simatic errors
      EEPROM_Poll_Result = Par_95 - 1000
    Else
      EEPROM_Poll_Result = Par_95
    EndIf : EndIf
  Else
    EEPROM_Poll_Result = EEPROM_SUPPORT_ERROR_TIMEOUT
  EndIf
EndFunction

'****************************************************************************
''' Converts an IPv4 address into a 32 bit value. Should be used with Simatic_Connect.
'''+e.g., IPv4_To_Long(192, 168, 1, 10) returns 0C0A8010Ah.
'''****************************************************************************
Function IPv4_To_Long(ip1, ip2, ip3, ip4) As Long
  IPv4_To_Long = Shift_Left(IP1, 24) Or (Shift_Left(IP2, 16) Or (Shift_Left(IP3, 8) Or IP4))
EndFunction

'<ENDREGION>

'<REGION> Get_Firmware_Version
'****************************************************************************
''' Returns the firmware version number of the ADwin Ethernet Interface.
'''+The version number is given as decimal value multiplied by 100, i.e. return value 274 equals version 2.74.
'''****************************************************************************
Function Get_Firmware_Version_Poll() As Long
  Get_Firmware_Version_Async_Start()
  Get_Firmware_Version_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_GET_FIRMWARE_VERSION)
EndFunction

'****************************************************************************
''' Starts reading the firmware version number of the ADwin Ethernet Interface.
'''+
'''+Read return value with EEPROM_Async_Result.
'''+Return value:  > 0 = version number is given as decimal value multiplied by 100, i.e. 274 equals version 2.74
'''+              -101 = Instruction is not completed yet.
'''+               < 0 = Error
'''****************************************************************************
Sub Get_Firmware_Version_Async_Start()
  Data_200[EEPROM_SUPPORT_LAST_COMMAND] = EEPROM_SUPPORT_GET_FIRMWARE_VERSION
  Par_95 = EEPROM_SUPPORT_GET_FIRMWARE_VERSION
  SEND_IRQ
EndSub
'<ENDREGION>

'<REGION> EEPROM_Read
'****************************************************************************
''' Reads a specified number of values from the EEPROM and stores the values in a global array Data_n.
'''+Return value < 0 means an error.
''' data_no:     Number n (1..199) of a global array Data_n, where EEPROM values are stored.
''' start_index: Position (1..n) in the EEPROM, where reading starts.
''' count:       Number (1..n) of data words to be transferred (1 word = 4 bytes).
'''****************************************************************************
Function EEPROM_Read_Poll(data_no, start_index, count) As Long
  EEPROM_Read_Async_Start(Data_No, Start_Index, Count)
  EEPROM_Read_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_EEPROM_READ)
EndFunction

'****************************************************************************
''' Starts reading specified values from the EEPROM. The values are stored in the global array Data_n.
'''+
'''+Read return value with EEPROM_Async_Result.
'''+Return value:    0 = Successfully completed.
'''+              -101 = Instruction is not completed yet.
'''+               < 0 = Error
''' data_no:     Number n (1..199) of a global array Data_n, where EEPROM values are stored.
''' start_index: Position (1..n) in the EEPROM, where reading starts.
''' count:       Number (1..n) of data words to be transferred (1 word = 4 bytes).
'''****************************************************************************
Sub EEPROM_Read_Async_Start(data_no, start_index, count)
  Data_200[EEPROM_SUPPORT_START_INDEX] = Start_Index
  Data_200[EEPROM_SUPPORT_Count] = Count
  Data_200[EEPROM_SUPPORT_DATA_NO] = Data_No
  Data_200[EEPROM_SUPPORT_LAST_COMMAND] = EEPROM_SUPPORT_EEPROM_READ
  Par_95 = EEPROM_SUPPORT_EEPROM_READ
  SEND_IRQ
EndSub
'<ENDREGION>

'<REGION> EEPROM_Write
'****************************************************************************
''' Writes a specified number of values from the global array Data_n into the EEPROM.
'''+Return value < 0 means an error.
''' data_no:     Number n (1..199) of the global array Data_n, where values are read from.
''' start_index: Position (1..n) in the EEPROM, where writingstarts.
''' count:       Number (1..n) of data words to be transferred (1 word = 4 bytes).
'''****************************************************************************
Function EEPROM_Write_Poll(data_no, start_index, count) As Long
  EEPROM_Write_Async_Start(Data_No, Start_Index, Count)
  EEPROM_Write_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_EEPROM_WRITE)
EndFunction

'****************************************************************************
''' Starts writing a specified number of values from the global array Data_n into the EEPROM.
'''+
'''+Read return value with EEPROM_Async_Result.
'''+Return value:    0 = Successfully completed.
'''+              -101 = Instruction is not completed yet.
'''+               < 0 = Error
''' data_no:     Number n (1..199) of a global array Data_n, where EEPROM values are stored.
''' start_index: Position (1..n) in the EEPROM, where reading starts.
''' count:       Number (1..n) of data words to be transferred (1 word = 4 bytes).
'''****************************************************************************
Sub EEPROM_Write_Async_Start(data_no, start_index, count)
  Data_200[EEPROM_SUPPORT_START_INDEX] = Start_Index
  Data_200[EEPROM_SUPPORT_Count] = Count
  Data_200[EEPROM_SUPPORT_DATA_NO] = Data_No
  Data_200[EEPROM_SUPPORT_LAST_COMMAND] = EEPROM_SUPPORT_EEPROM_WRITE
  Par_95 = EEPROM_SUPPORT_EEPROM_WRITE
  SEND_IRQ
EndSub
'<ENDREGION>

'<REGION> Get_Localtime
#define LOCALTIME_RESULT_DATA_SIZE      20
#define LOCALTIME_INDEX_HOURS            1                  ' 0-23
#define LOCALTIME_INDEX_MINUTES          2                  ' 0-60
#define LOCALTIME_INDEX_SECONDS          3                  ' 0-60
#define LOCALTIME_INDEX_YEAR             4                  ' eg. 2014
#define LOCALTIME_INDEX_MONTH            5                  ' 1-12
#define LOCALTIME_INDEX_DAY              6                  ' 1-31
#define LOCALTIME_INDEX_WEEKDAY          7                  ' 0-6, 0 = Sunday
#define LOCALTIME_INDEX_DAY_OF_YEAR      8                  ' 0-365, 0 = Jan 1
#define LOCALTIME_INDEX_IS_DST           9                  ' daylight saving time flag
#define LOCALTIME_INDEX_UNIX_TIMESTAMP  10                  ' unix timestamp, seconds since 1970
'****************************************************************************
''' Get localtime from Ethernet module.
'''+Return value < 0 means an error.
''' data_no:     Number n (1..199) of a global array Data_n, minimum size 
'''+             LOCALTIME_RESULT_DATA_SIZE, where the localtime is stored.
''' start_index: Position (1..n) in the data_no, where reading starts.
'''****************************************************************************
Function Get_Localtime_Poll(data_no, start_index) As Long
  Get_Localtime_Async_Start(Data_No, Start_Index)
  Get_Localtime_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_EEPROM_GET_LOCALTIME)
EndFunction

'****************************************************************************
''' Start get localtime from Ethernet module.
'''+
'''+Read return value with EEPROM_Async_Result.
'''+Return value:    0 = Successfully completed.
'''+              -101 = Instruction is not completed yet.
'''+               < 0 = Error
''' data_no:     Number n (1..199) of a global array Data_n, minimum size 
'''+             LOCALTIME_RESULT_DATA_SIZE, where the localtime is stored.
''' start_index: Position (1..n) in the data_no, where reading starts.
'''****************************************************************************
Sub Get_Localtime_Async_Start(data_no, start_index)
  Data_200[EEPROM_SUPPORT_START_INDEX] = Start_Index
  Data_200[EEPROM_SUPPORT_DATA_NO] = Data_No
  Data_200[EEPROM_SUPPORT_LAST_COMMAND] = EEPROM_SUPPORT_EEPROM_GET_LOCALTIME
  Par_95 = EEPROM_SUPPORT_EEPROM_GET_LOCALTIME
  SEND_IRQ
EndSub
'<ENDREGION>

'<REGION> Set_Error_Text_Data
#define ERROR_TEXT_DATA_SIZE      200
'****************************************************************************
''' Designate a String Data for detailed error messages from EEPROM Support.
'''+Return value < 0 means an error.
''' data_no:     Number n (1..199) of a global array Data_n, minimum size 
'''+             ERROR_TEXT_DATA_SIZE, where error messages are stored.
'''****************************************************************************
Function Set_Error_Text_Data_Poll(data_no) As Long
  Set_Error_Text_Data_Async_Start(Data_No)
  Set_Error_Text_Data_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_EEPROM_SET_ERROR_TEXT_DATA)
EndFunction

'****************************************************************************
''' Designate a String Data for detailed error messages from EEPROM Support.
'''+
'''+Read return value with EEPROM_Async_Result.
'''+Return value:    0 = Successfully completed.
'''+              -101 = Instruction is not completed yet.
'''+               < 0 = Error
''' data_no:     Number n (1..199) of a global array Data_n, minimum size 
'''+             ERROR_TEXT_DATA_SIZE, where error messages are stored.
'''****************************************************************************
Sub Set_Error_Text_Data_Async_Start(data_no)
  Data_200[EEPROM_SUPPORT_DATA_NO] = Data_No
  Data_200[EEPROM_SUPPORT_LAST_COMMAND] = EEPROM_SUPPORT_EEPROM_SET_ERROR_TEXT_DATA
  Par_95 = EEPROM_SUPPORT_EEPROM_SET_ERROR_TEXT_DATA
  SEND_IRQ
EndSub
'<ENDREGION>

'<REGION> Flash_Read
'****************************************************************************
''' Reads a specified number of values from the flash memory and stores the values in a global array Data_n.
'''+Return value < 0 means an error.
''' data_no:     Number n (1..199) of a global array Data_n, where flash values are stored.
''' start_index: Position (1..n) in the flash memory, where reading starts.
''' count:       Number (1..n) of data words to be transferred (1 word = 4 bytes).
'''****************************************************************************
Function Flash_Read_Poll(data_no, start_index, count) As Long  '<HIDE>
  Flash_Read_Async_Start(Data_No, Start_Index, Count)
  Flash_Read_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_FLASH_READ)
EndFunction

'****************************************************************************
''' Starts reading a specified number of values from the flash memory. The values are stored in a global array Data_n.
'''+
'''+Read return value with Flash_Async_Result.
'''+Return value:    0 = Successfully completed.
'''+              -101 = Instruction is not completed yet.
'''+               < 0 = Error
''' data_no:     Number n (1..199) of a global array Data_n, where flash values are stored.
''' start_index: Position (1..n) in the flash memory, where reading starts.
''' count:       Number (1..n) of data words to be transferred (1 word = 4 bytes).
'''****************************************************************************
Sub Flash_Read_Async_Start(data_no, start_index, count)     '<HIDE>
  Data_200[EEPROM_SUPPORT_START_INDEX] = Start_Index
  Data_200[EEPROM_SUPPORT_Count] = Count
  Data_200[EEPROM_SUPPORT_DATA_NO] = Data_No
  Data_200[EEPROM_SUPPORT_LAST_COMMAND] = EEPROM_SUPPORT_FLASH_READ
  Par_95 = EEPROM_SUPPORT_FLASH_READ
  SEND_IRQ
EndSub
'<ENDREGION>

'<REGION> Flash_Write
'****************************************************************************
''' Writes a specified number of values from a global array Data_n to the flash memory.
'''+Return value < 0 means an error.
''' data_no:     Number n (1..199) of a global array Data_n, where values are read.
''' start_index: Position (1..n) in the flash memory, where writing starts.
''' count:       Number (1..n) of data words to be transferred (1 word = 4 bytes).
'''****************************************************************************
Function Flash_Write_Poll(data_no, start_index, count) As Long  '<HIDE>
  Flash_Write_Async_Start(Data_No, Start_Index, Count)
  Flash_Write_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_FLASH_WRITE)
EndFunction

'****************************************************************************
''' Starts writing a specified number of values from a global array Data_n to the flash memory.
'''+
'''+Read return value with Flash_Async_Result.
'''+Return value:    0 = Successfully completed.
'''+              -101 = Instruction is not completed yet.
'''+               < 0 = Error
''' data_no:     Number n (1..199) of a global array Data_n, where values are read.
''' start_index: Position (1..n) in the flash memory, where writing starts.
''' count:       Number (1..n) of data words to be transferred (1 word = 4 bytes).
'''****************************************************************************
Sub Flash_Write_Async_Start(data_no, start_index, count)    '<HIDE>
  Data_200[EEPROM_SUPPORT_START_INDEX] = Start_Index
  Data_200[EEPROM_SUPPORT_Count] = Count
  Data_200[EEPROM_SUPPORT_DATA_NO] = Data_No
  Data_200[EEPROM_SUPPORT_LAST_COMMAND] = EEPROM_SUPPORT_FLASH_WRITE
  Par_95 = EEPROM_SUPPORT_FLASH_WRITE
  SEND_IRQ
EndSub
'<ENDREGION>

'<REGION> Flash_Get_Size
'****************************************************************************
''' Returns the size of reserved flash memory.
'''+Return value < 0 means an error.
'''****************************************************************************
Function Flash_Get_Size_Poll() As Long                      '<HIDE>
  Flash_Get_Size_Async_Start()
  Flash_Get_Size_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_GET_FLASH_SIZE)
EndFunction

'****************************************************************************
''' Starts  reading the size of reserved flash memory.
'''+
'''+Read return value with Flash_Async_Result.
'''+Return value:    0 = Successfully completed.
'''+              -101 = Instruction is not completed yet.
'''+               < 0 = Error
'''****************************************************************************
Sub Flash_Get_Size_Async_Start()                            '<HIDE>
  Par_95 = EEPROM_SUPPORT_GET_FLASH_SIZE
  Data_200[EEPROM_SUPPORT_LAST_COMMAND] = EEPROM_SUPPORT_GET_FLASH_SIZE
  SEND_IRQ
EndSub
'<ENDREGION>

'<REGION> Flash_Set_Size
'****************************************************************************
''' Reserves and initializes a memory area of the flash memory.
'''+Return value < 0 means an error.
''' flash_size:  Size of the flash memory to be reserved, given in words (1 word = 4 bytes).
'''****************************************************************************
Function Flash_Set_Size_Poll(flash_size) As Long            '<HIDE>
  Flash_Set_Size_Async_Start(Flash_Size)
  Flash_Set_Size_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_SET_FLASH_SIZE)
EndFunction

'****************************************************************************
''' Starts reserving and initializing a memory area of the flash memory.
'''+
'''+Read return value with Flash_Async_Result.
'''+Return value:    0 = Successfully completed.
'''+              -101 = Instruction is not completed yet.
'''+               < 0 = Error
''' flash_size:  Size of the flash memory to be reserved, given in words (1 word = 4 bytes).
'''****************************************************************************
Sub Flash_Set_Size_Async_Start(flash_size)                  '<HIDE>
  Data_200[EEPROM_SUPPORT_COUNT] = Flash_Size
  Data_200[EEPROM_SUPPORT_LAST_COMMAND] = EEPROM_SUPPORT_SET_FLASH_SIZE
  Par_95 = EEPROM_SUPPORT_SET_FLASH_SIZE
  SEND_IRQ
EndSub
'<ENDREGION>

'<REGION> Flash_Get_Free_Space
'****************************************************************************
''' Returns the size of free memory in the flash memory.
'''+Return value < 0 means an error.
'''****************************************************************************
Function Flash_Get_Free_Space_Poll() As Long                '<HIDE>
  Flash_Get_Free_Space_Async_Start()
  Flash_Get_Free_Space_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_GET_FREE_FLASH_SPACE)
EndFunction

'****************************************************************************
''' Starts reading the size of free memory in the flash memory.
'''+
'''+Read return value with Flash_Async_Result.
'''+Return value:    0 = Successfully completed.
'''+              -101 = Instruction is not completed yet.
'''+               < 0 = Error
'''****************************************************************************
Sub Flash_Get_Free_Space_Async_Start()                      '<HIDE>
  Par_95 = EEPROM_SUPPORT_GET_FREE_FLASH_SPACE
  Data_200[EEPROM_SUPPORT_LAST_COMMAND] = EEPROM_SUPPORT_GET_FREE_FLASH_SPACE
  SEND_IRQ
EndSub
'<ENDREGION>

'<REGION> Simatic_Connect
'****************************************************************************
''' Builds a fetch/write data connection to a Simatic PLC.
'''+Use IPv4_To_Long to convert the IP address to the required 32 bit format.
'''+Return value < 0 means an error.
''' ip_address:  IP address of the Simatic PLC in the Ethernet network as 32 bit value.
''' port_fetch:  Port number (1..65535) of the projected fetch connection.
''' port_write:  Port number (1..65535) of the projected write connection.
''' tcp_timeout: TCP timeout (> 0) in seconds.
'''****************************************************************************
Function Simatic_Connect_Poll(ip_address, port_fetch, port_write, tcp_timeout) As Long
  Simatic_Connect_Async_Start(IP_Address, Port_Fetch, Port_Write, TCP_Timeout)
  Simatic_Connect_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_SFW_CONNECT)
EndFunction

'****************************************************************************
''' Starts building a fetch/write data connection to a Simatic PLC.
'''+Use IPv4_To_Long to convert the IP address to the required 32 bit format.
'''+
'''+Read return value with Simatic_Async_Result.
'''+Return value:    0 = Successfully completed.
'''+              -101 = Instruction is not completed yet.
'''+               < 0 = Error
''' ip_address:  IP address of the Simatic PLC in the Ethernet network as 32 bit value.
''' port_fetch:  Port number (1..65535) of the projected fetch connection.
''' port_write:  Port number (1..65535) of the projected write connection.
''' tcp_timeout: TCP timeout (> 0) in seconds.
'''****************************************************************************
Sub Simatic_Connect_Async_Start(ip_address, port_fetch, port_write, tcp_timeout)
  If ((Port_Fetch < 1) Or (Port_Fetch > 0ffffh)) Then
    Par_95 = EEPROM_SUPPORT_ERROR_INVALID_PORT_NUMBER
  Else : If ((Port_Write < 1) Or (Port_Write > 0ffffh)) Then
    Par_95 = EEPROM_SUPPORT_ERROR_INVALID_PORT_NUMBER
  Else : If (TCP_Timeout < 0) Then
    Par_95 = EEPROM_SUPPORT_ERROR_INVALID_TIMEOUT
  Else
    Data_199[EEPROM_SUPPORT_D199_IP_ADDRESS] = IP_Address
    Data_199[EEPROM_SUPPORT_D199_PORT_NUMBER_FETCH] = Port_Fetch
    Data_199[EEPROM_SUPPORT_D199_PORT_NUMBER_WRITE] = Port_Write
    Data_199[EEPROM_SUPPORT_D199_TCP_TIMEOUT] = TCP_Timeout
    Data_200[EEPROM_SUPPORT_LAST_COMMAND] = EEPROM_SUPPORT_SFW_CONNECT
    Par_95 = EEPROM_SUPPORT_SFW_CONNECT
    SEND_IRQ
  EndIf : EndIf : EndIf
EndSub
'<ENDREGION>

'<REGION> Simatic_Close
'****************************************************************************
''' Closes the data connection to the Simatic PLC.
'''+Return value < 0 means an error.
'''****************************************************************************
Function Simatic_Close_Poll() As Long
  Simatic_Close_Async_Start()
  Simatic_Close_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_SFW_CLOSE)
EndFunction

'****************************************************************************
''' Starts closing the data connection to the Simatic PLC.
'''+
'''+Read return value with Simatic_Async_Result.
'''+Return value:    0 = Successfully completed.
'''+              -101 = Instruction is not completed yet.
'''+               < 0 = Error
'''****************************************************************************
Sub Simatic_Close_Async_Start()
  Data_200[EEPROM_SUPPORT_LAST_COMMAND] = EEPROM_SUPPORT_SFW_CLOSE
  Par_95 = EEPROM_SUPPORT_SFW_CLOSE
  SEND_IRQ
EndSub
'<ENDREGION>

'<REGION> Simatic_Fetch
'****************************************************************************
''' Reads specified values from the Simatic PLC and stores them in a global array Data_n.
'''+Return value < 0 means an error.
''' data_no:       Number n (1..198,200) of the global array Data_n, where PLC values are stored.
''' mem_type:      Type of the accessed memory in the Simatic PLC. Use one of the following constants:
'''+               SIMATIC_MEMORY_TYPE_DB (1):    DB
'''+               SIMATIC_MEMORY_TYPE_M (2):     M
'''+               SIMATIC_MEMORY_TYPE_E (3):     E
'''+               SIMATIC_MEMORY_TYPE_A (4):     A
'''+               SIMATIC_MEMORY_TYPE_PE_PA (5): PE/PA
'''+               SIMATIC_MEMORY_TYPE_Z (6):     Z
'''+               SIMATIC_MEMORY_TYPE_T (7):     T
''' mem_block_no:  Number (1..255) of the accessed memory block in the Simatic PLC.
''' start_index:   Position (1..n) in the accessed memory block, where reading starts.
''' count:         Number (1..n) of data words to be transferred (1 word = 4 bytes).
'''****************************************************************************
Function Simatic_Fetch_Poll(data_no, mem_type, mem_block_no, start_index, count) As Long
  Simatic_Fetch_Async_Start(data_no, mem_type, mem_block_no, start_index, Count)
  Simatic_Fetch_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_SFW_FETCH)
EndFunction

'****************************************************************************
''' Starts reading specified values from the Simatic PLC. The values are stored in the global array Data_n.
'''+
'''+Read return value with Simatic_Async_Result.
'''+Return value:    0 = Successfully completed.
'''+              -101 = Instruction is not completed yet.
'''+               < 0 = Error
''' data_no:       Number n (1..198,200) of the global array Data_n, where PLC values are stored.
''' mem_type:      Type of the accessed memory in the Simatic PLC. Use one of the following constants:
'''+               SIMATIC_MEMORY_TYPE_DB (1):    DB
'''+               SIMATIC_MEMORY_TYPE_M (2):     M
'''+               SIMATIC_MEMORY_TYPE_E (3):     E
'''+               SIMATIC_MEMORY_TYPE_A (4):     A
'''+               SIMATIC_MEMORY_TYPE_PE_PA (5): PE/PA
'''+               SIMATIC_MEMORY_TYPE_Z (6):     Z
'''+               SIMATIC_MEMORY_TYPE_T (7):     T
''' mem_block_no:  Number (1..255) of the accessed memory block in the Simatic PLC.
''' start_index:   Position (1..n) in the accessed memory block, where reading starts.
''' count:         Number (1..n) of data words to be transferred (1 word = 4 bytes).
'''****************************************************************************
Sub Simatic_Fetch_Async_Start(data_no, mem_type, mem_block_no, start_index, count)
  If ((data_no < 1) Or (data_no > 198)) Then
    Par_95 = EEPROM_SUPPORT_ERROR_INVALID_DATA_NUMBER
  Else : If ((mem_type < SIMATIC_MEMORY_TYPE_DB) Or (mem_type > SIMATIC_MEMORY_TYPE_T)) Then
    Par_95 = EEPROM_SUPPORT_ERROR_INVALID_MEMORY_TYPE
  Else : If ((mem_block_no < 1) Or (mem_block_no > 255)) Then
    Par_95 = EEPROM_SUPPORT_ERROR_INVALID_MEMORY_BLOCK_NUMBER 
  Else : If (start_index < 0) Then
    Par_95 = EEPROM_SUPPORT_ERROR_INVALID_START_ADDRESS
  Else : If ((Count < 4) Or (Count > 0ffffh)) Then
    Par_95 = EEPROM_SUPPORT_ERROR_INVALID_COUNT          
  Else : If ((Count / 4 * 4 <> Count)) Then
    ' Count must be aligned to 4 bytes
    Par_95 = EEPROM_SUPPORT_ERROR_INVALID_COUNT          
  Else
    Data_199[EEPROM_SUPPORT_D199_DATA_NUMBER_FETCH] = data_no
    Data_199[EEPROM_SUPPORT_D199_COUNT_FETCH] = Count
    Data_199[EEPROM_SUPPORT_D199_START_ADDRESS_FETCH] = start_index
    Data_199[EEPROM_SUPPORT_D199_MEMORY_BLOCK_NUMBER_FETCH] = mem_block_no
    Data_199[EEPROM_SUPPORT_D199_MEMORY_TYPE_FETCH] = mem_type
    Data_200[EEPROM_SUPPORT_LAST_COMMAND] = EEPROM_SUPPORT_SFW_FETCH
    Par_95 = EEPROM_SUPPORT_SFW_FETCH
    SEND_IRQ
  EndIf : EndIf : EndIf : EndIf : EndIf : EndIf
EndSub
'<ENDREGION>

'<REGION> Simatic_Write
'****************************************************************************
''' Writes values from a global array Data_n into specified memory blocks of the Simatic PLC.
'''+Return value < 0 means an error.
''' data_no:       Number n (1..198,200) of the global array Data_n with the values to be transferred.
''' mem_type:      Type of the accessed memory in the Simatic PLC. Use one of the following constants:
'''+               SIMATIC_MEMORY_TYPE_DB (1):    DB
'''+               SIMATIC_MEMORY_TYPE_M (2):     M
'''+               SIMATIC_MEMORY_TYPE_E (3):     E
'''+               SIMATIC_MEMORY_TYPE_A (4):     A
'''+               SIMATIC_MEMORY_TYPE_PE_PA (5): PE/PA
'''+               SIMATIC_MEMORY_TYPE_Z (6):     Z
'''+               SIMATIC_MEMORY_TYPE_T (7):     T
''' mem_block_no:  Number (1..255) of the accessed memory block in the Simatic PLC.
''' start_index:   Position (1..n) in the accessed memory block, where writing starts.
''' count:         Number (1..n) of data words to be transferred (1 word = 4 bytes).
'''****************************************************************************
Function Simatic_Write_Poll(data_number, memeory_type, memory_block_number, start_address, count) As Long
  Simatic_Write_Async_Start(Data_Number, Memeory_Type, Memory_Block_Number, Start_Address, Count)
  Simatic_Write_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_SFW_WRITE)
EndFunction

'****************************************************************************
''' Starts writing values from a global array Data_n into specified memory blocks of the Simatic PLC.
'''+
'''+Read return value with Simatic_Async_Result.
'''+Return value:    0 = Successfully completed.
'''+              -101 = Instruction is not completed yet.
'''+               < 0 = Error
''' data_no:       Number n (1..198,200) of the global array Data_n with the values to be transferred.
''' mem_type:      Type of the accessed memory in the Simatic PLC. Use one of the following constants:
'''+               SIMATIC_MEMORY_TYPE_DB (1):    DB
'''+               SIMATIC_MEMORY_TYPE_M (2):     M
'''+               SIMATIC_MEMORY_TYPE_E (3):     E
'''+               SIMATIC_MEMORY_TYPE_A (4):     A
'''+               SIMATIC_MEMORY_TYPE_PE_PA (5): PE/PA
'''+               SIMATIC_MEMORY_TYPE_Z (6):     Z
'''+               SIMATIC_MEMORY_TYPE_T (7):     T
''' mem_block_no:  Number (1..255) of the accessed memory block in the Simatic PLC.
''' start_index:   Position (1..n) in the accessed memory block, where writing starts.
''' count:         Number (1..n) of data words to be transferred (1 word = 4 bytes).
'''****************************************************************************
Sub Simatic_Write_Async_Start(data_number, memory_type, memory_block_number, start_address, count)
  If ((Data_Number < 1) Or (Data_Number > 198)) Then
    Par_95 = EEPROM_SUPPORT_ERROR_INVALID_DATA_NUMBER
  Else : If ((Memory_Type < SIMATIC_MEMORY_TYPE_DB) Or (Memory_Type > SIMATIC_MEMORY_TYPE_T)) Then
    Par_95 = EEPROM_SUPPORT_ERROR_INVALID_MEMORY_TYPE
  Else : If ((Memory_Block_Number < 1) Or (Memory_Block_Number > 255)) Then
    Par_95 = EEPROM_SUPPORT_ERROR_INVALID_MEMORY_BLOCK_NUMBER 
  Else : If (Start_Address < 0) Then
    Par_95 = EEPROM_SUPPORT_ERROR_INVALID_START_ADDRESS
  Else : If ((Count < 4) Or (Count > 0ffffh)) Then
    Par_95 = EEPROM_SUPPORT_ERROR_INVALID_COUNT
  Else : If ((Count / 4 * 4 <> Count)) Then
    ' Count must be aligned to 4 bytes
    Par_95 = EEPROM_SUPPORT_ERROR_INVALID_COUNT
  Else
    Data_199[EEPROM_SUPPORT_D199_DATA_NUMBER_WRITE] = Data_Number
    Data_199[EEPROM_SUPPORT_D199_COUNT_WRITE] = Count
    Data_199[EEPROM_SUPPORT_D199_START_ADDRESS_WRITE] = Start_Address
    Data_199[EEPROM_SUPPORT_D199_MEMORY_BLOCK_NUMBER_WRITE] = Memory_Block_Number
    Data_199[EEPROM_SUPPORT_D199_MEMORY_TYPE_WRITE] = Memory_Type
    Data_200[EEPROM_SUPPORT_LAST_COMMAND] = EEPROM_SUPPORT_SFW_WRITE
    Par_95 = EEPROM_SUPPORT_SFW_WRITE
    SEND_IRQ
  EndIf : EndIf : EndIf : EndIf : EndIf : EndIf 
EndSub
'<ENDREGION>

'<REGION> Simatic_Set_Polling_Delay
'****************************************************************************
''' Sets the polling delay. Polling delay is used to read Par_95.
'''+Return value < 0 means an error.
''' polling_delay:  Delay in milliseconds,
'''****************************************************************************
Function Simatic_Set_Polling_Delay_Poll(polling_delay) As Long  '<HIDE>
  Simatic_Set_Polling_Delay_Async_Start(Polling_Delay)
  Simatic_Set_Polling_Delay_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_SFW_SET_POLLING_DELAY)
EndFunction

'****************************************************************************
''' Starts setting the polling delay. Polling delay is used to read Par_95.
'''+
'''+Read return value with Simatic_Async_Result.
'''+Return value:    0 = Successfully completed.
'''+              -101 = Instruction is not completed yet.
'''+               < 0 = Error
''' polling_delay:  Delay in milliseconds,
'''****************************************************************************
Sub Simatic_Set_Polling_Delay_Async_Start(polling_delay)    '<HIDE>
  Data_199[EEPROM_SUPPORT_D199_POLLING_DELAY] = Polling_Delay
  Data_200[EEPROM_SUPPORT_LAST_COMMAND] = EEPROM_SUPPORT_SFW_SET_POLLING_DELAY
  Par_95 = EEPROM_SUPPORT_SFW_SET_POLLING_DELAY
  SEND_IRQ
EndSub
'<ENDREGION>

'****************************************************************************
''' Returns the status of the previously used asynchronous EEPROM instruction.
'''+Return value:
'''+         0 = EEPROM_SUPPORT_OK: no error
'''+        -1 = EEPROM_SUPPORT_ERROR_UNKNOWN_COMMAND:             unknown command
'''+        -2 = EEPROM_SUPPORT_ERROR_INVALID_POSITION:            invalid position in an EEPROM
'''+        -3 = EEPROM_SUPPORT_ERROR_INVALID_COUNT:               invalid number of values
'''+        -4 = EEPROM_SUPPORT_ERROR_INVALID_COUNT_AND_POSITION:  invalid position in an EEPROM and invalid data number
'''+        -5 = EEPROM_SUPPORT_ERROR_DATA_200_ACCESS_ERROR:       Error accessing Data_200
'''+        -6 = EEPROM_SUPPORT_ERROR_DATA_ACCESS_ERROR:           Error accessing source / destination array Data_n
'''+        -7 = EEPROM_SUPPORT_ERROR_EEPROM_READ_ERROR:           Error while reading from EEPROM
'''+        -8 = EEPROM_SUPPORT_ERROR_EEPROM_WRITE_ERROR:          Error while writing to EEPROM
'''+      -100 = EEPROM_SUPPORT_ERROR_TIMEOUT:                     Timeout while accessing the EEPROM
'''+      -101 = EEPROM_SUPPORT_ERROR_NOT_READY:                   The previous command has not been completed yet
'''****************************************************************************
Function EEPROM_Async_Result() As Long
  SEND_IRQ
  If (Par_95 <> Data_200[EEPROM_SUPPORT_LAST_COMMAND]) Then
    ' for the commands Get_Flash_Size and Get_Free_Flash_Space the returned value is in Data_200, which we want to hide from the user
    If (((Data_200[EEPROM_SUPPORT_LAST_COMMAND] = EEPROM_SUPPORT_GET_FLASH_SIZE) Or (Data_200[EEPROM_SUPPORT_LAST_COMMAND] = EEPROM_SUPPORT_GET_FREE_FLASH_SPACE)) And (Par_95 = 0)) Then
      EEPROM_Async_Result = Data_200[EEPROM_SUPPORT_RESULT]
      ' some simatic error codes clashed with flash error codes, so move all pure simatic errors by -1000
    Else : If ((((Data_200[EEPROM_SUPPORT_LAST_COMMAND] >= EEPROM_SUPPORT_SFW_CONNECT) And (Data_200[EEPROM_SUPPORT_LAST_COMMAND] <= EEPROM_SUPPORT_SFW_SET_POLLING_DELAY)) And (Par_95 < -8)) and (Par_95 > -1000)) Then
      ' offset for Simatic errors
      EEPROM_Async_Result = Par_95 - 1000
    Else
      EEPROM_Async_Result = Par_95
    EndIf : EndIf
  Else 
    EEPROM_Async_Result = EEPROM_SUPPORT_ERROR_NOT_READY
  EndIf
EndFunction

'****************************************************************************
''' Returns the status of the previously used asynchronous Flash instruction.
'''+Return value:
'''+         0 = EEPROM_SUPPORT_OK: no error
'''+        -1 = EEPROM_SUPPORT_ERROR_UNKNOWN_COMMAND:  Unknown command
'''+       -10 = EPROM_SUPPORT_ERROR_FLASH_ALLOC:       Error while allocating dynamic memory in the flash memory
'''+       -11 = EEPROM_SUPPORT_ERROR_FLASH_ACCESS:     Error while accessing the data file in the flash memory
'''+      -100 = EEPROM_SUPPORT_ERROR_TIMEOUT:          Timeout while accessing the EEPROM
'''+      -101 = EEPROM_SUPPORT_ERROR_NOT_READY:        The previous command has not been completed yet
'''****************************************************************************
Function Flash_Async_Result() As Long                       '<HIDE>
  Flash_Async_Result = EEPROM_Async_Result()
EndFunction

'****************************************************************************
''' Returns the status of the previously used asynchronous Simatic instruction.
'''+Return value:
'''+         0 = EEPROM_SUPPORT_OK: no error
'''+        -1 = EEPROM_SUPPORT_ERROR_UNKNOWN_COMMAND:        Unknown command
'''+      -100 = EEPROM_SUPPORT_ERROR_TIMEOUT:                Timeout while accessing the EEPROM
'''+      -101 = EEPROM_SUPPORT_ERROR_NOT_READY:  The previous command has not been completed yet
'''+     -1010 = EEPROM_SUPPORT_ERROR_DATA_199_ACCESS_ERROR:  Error accessing Data_199
'''+     -1011 = EEPROM_SUPPORT_ERROR_CANNOT_CONNECT:         Cannot build connection to PLC
'''+     -1012 = EEPROM_SUPPORT_ERROR_NOT_CONNECTED:          Connection to PLC missing
'''+     -1013 = EEPROM_SUPPORT_ERROR_MISSING_ACK_FETCH:      Missing acknowledge while reading from the PLC
'''+     -1014 = EEPROM_SUPPORT_ERROR_ACK_ERROR_FETCH:        Acknowledge error while reading from the PLC
'''+     -1015 = EEPROM_SUPPORT_ERROR_RECEIVE_ERROR:          Error while reading from the PLC
'''+     -1016 = EEPROM_SUPPORT_ERROR_FETCH_DATA_ACCESS_ERROR: Error while writing into destination array Data_n
'''+     -1017 = EEPROM_SUPPORT_ERROR_MISSING_ACK_WRITE:      Missing acknowledge while writing to PLC
'''+     -1018 = EEPROM_SUPPORT_ERROR_ACK_ERROR_WRITE:        Acknowledge error while writing to PLC
'''+     -1019 = EEPROM_SUPPORT_ERROR_WRITE_ERROR:            Error while writing to PLC
'''+     -1020 = EEPROM_SUPPORT_ERROR_WRITE_DATA_ACCESS_ERROR: Error while reading from source array Data_n
'''+     -1021 = EEPROM_SUPPORT_ERROR_INVALID_POLLING_DELAY:  Invalid polling delay
'''+     -1022 = EEPROM_SUPPORT_ERROR_INVALID_DATA_NUMBER:    Invalid number n of a global array Data_n
'''+     -1023 = EEPROM_SUPPORT_ERROR_INVALID_MEMORY_TYPE:    Invalid memory type of the Simatic PLC
'''+     -1024 = EEPROM_SUPPORT_ERROR_INVALID_MEMORY_BLOCK_NUMBER :  Invalid block number of the Simatic PLC
'''+     -1025 = EEPROM_SUPPORT_ERROR_INVALID_START_ADDRESS:   Invalid start address in the Simatic PLC memory block
'''+     -1027 = EEPROM_SUPPORT_ERROR_INVALID_PORT_NUMBER:    Invalid port number for a projected fetch/write connection
'''+     -1028 = EEPROM_SUPPORT_ERROR_INVALID_TIMEOUT:        Invalid TCP timeout value for a fetch/write connection
'''****************************************************************************
Function Simatic_Async_Result() As Long
  Simatic_Async_Result = EEPROM_Async_Result()
EndFunction

'<REGION> Create Partitions

'****************************************************************************
''' Creates a partition table on storage_device.
'''+
'''+Returns EEPROM_SUPPORT_OK (0) on success, or a negative value on error 
'''+(see #Define EEPROM_SUPPORT_ERROR_* at the beginning of EEPROM_Support.inc)
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_info: data number for additional partition information, currently unused, use -1
'''****************************************************************************
Function Storage_Create_Partitions_Poll(storage_device, partition_info) As Long
  STORAGE_Create_Partitions_Async_Start(storage_device, partition_info)
  STORAGE_Create_Partitions_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_STORAGE_CREATE_PARTITIONS)
EndFunction

'****************************************************************************
''' Starts creating a partition table on storage_device.
'''+
'''+Read return value with Storage_Async_Result.
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_info: data number for additional partition information, currently unused, use -1
'''****************************************************************************
Sub Storage_Create_Partitions_Async_Start(storage_device, partition_info)
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DEVICE] = storage_device
  Data_200[EEPROM_SUPPORT_D200_STORAGE_PARTITION] = partition_info
  Data_200[EEPROM_SUPPORT_D200_STORAGE_LAST_COMMAND] = EEPROM_SUPPORT_STORAGE_CREATE_PARTITIONS
  Par_95 = EEPROM_SUPPORT_STORAGE_CREATE_PARTITIONS
  SEND_IRQ
EndSub
'<ENDREGION>

'<REGION> Format
#define EEPROM_SUPPORT_FILESYSTEM_TYPE_EXT3  0
#define EEPROM_SUPPORT_FILESYSTEM_TYPE_FAT32 1
'****************************************************************************
''' Formats partition on the SATA device connected to storage_device.
'''+
'''+Returns EEPROM_SUPPORT_OK (0) on success, or a negative value on error 
'''+(see #Define EEPROM_SUPPORT_ERROR_* at the beginning of EEPROM_Support.inc)
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' filesystem:    0: ext3
'''+               1: fat32
''' format_infos: data number for additional information, currently unused, use 0
'''****************************************************************************
Function Storage_Format_Poll(storage_device, partition_number, filesystem, format_infos) As Long
  Storage_Format_Async_Start(storage_device, partition_number, filesystem, format_infos)
  Storage_Format_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_STORAGE_FORMAT)
EndFunction

'****************************************************************************
''' Starts formatting a partition on the SATA device connected to storage_device.
'''+
'''+Read return value with Storage_Async_Result.
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' filesystem:    0: ext3
'''+               1: fat32
''' format_infos: data number for additional information, currently unused, use 0
'''****************************************************************************
Sub Storage_Format_Async_Start(storage_device, partition_number, filesystem, format_infos)
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DEVICE] = storage_device
  Data_200[EEPROM_SUPPORT_D200_STORAGE_PARTITION] = partition_number
  Data_200[EEPROM_SUPPORT_D200_STORAGE_FILENAME] = filesystem
  Data_200[EEPROM_SUPPORT_D200_STORAGE_INFOS] = format_infos
  Data_200[EEPROM_SUPPORT_D200_STORAGE_LAST_COMMAND] = EEPROM_SUPPORT_STORAGE_FORMAT
  Par_95 = EEPROM_SUPPORT_STORAGE_FORMAT
  SEND_IRQ
EndSub
'<ENDREGION>

'<REGION> Mount/Unmount
'****************************************************************************
''' Mounts a filesystem on a partition on the SATA device connected to storage_device
'''+
'''+Returns EEPROM_SUPPORT_OK (0) on success, or a negative value on error 
'''+(see #Define EEPROM_SUPPORT_ERROR_* at the beginning of EEPROM_Support.inc)
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' filesystem:    0: ext3
'''+               1: fat32
''' mount_infos: data number for additional information, use 0 if not needed
'''+             if specified, data index 1 = 1 -> export dir via NFS   RO
'''+             if specified, data index 1 = 2 -> export dir via NFS   R/W
'''+             if specified, data index 2 = 1 -> export dir via Samba RO
'''+             if specified, data index 2 = 2 -> export dir via Samba R/W
'''****************************************************************************
Function Storage_Mount_Poll(storage_device, partition_number, filesystem, mount_infos) As Long
  Storage_Mount_Async_Start(storage_device, partition_number, filesystem, mount_infos)
  Storage_Mount_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_STORAGE_MOUNT)
EndFunction

'****************************************************************************
''' Mount the filesystem on a partition on the SATA device connected to storage_device.
'''+
'''+Read return value with Storage_Async_Result.
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' filesystem:    0: ext3
'''+               1: fat32
''' mount_infos: data number for additional information, use 0 if not needed
'''+             if specified, data index 1 = 1 -> export dir via NFS   RO
'''+             if specified, data index 1 = 2 -> export dir via NFS   R/W
'''+             if specified, data index 2 = 1 -> export dir via Samba RO
'''+             if specified, data index 2 = 2 -> export dir via Samba R/W
'''****************************************************************************
Sub Storage_Mount_Async_Start(storage_device, partition_number, filesystem, mount_infos)
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DEVICE] = storage_device
  Data_200[EEPROM_SUPPORT_D200_STORAGE_PARTITION] = partition_number
  Data_200[EEPROM_SUPPORT_D200_STORAGE_FILENAME] = filesystem
  Data_200[EEPROM_SUPPORT_D200_STORAGE_INFOS] = mount_infos
  Data_200[EEPROM_SUPPORT_D200_STORAGE_LAST_COMMAND] = EEPROM_SUPPORT_STORAGE_MOUNT
  Par_95 = EEPROM_SUPPORT_STORAGE_MOUNT
  SEND_IRQ
EndSub

'****************************************************************************
''' Unmounts a filesystem on a partition on the SATA device connected to storage_device
'''+
'''+Returns EEPROM_SUPPORT_OK (0) on success, or a negative value on error 
'''+(see #Define EEPROM_SUPPORT_ERROR_* at the beginning of EEPROM_Support.inc)
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
'''****************************************************************************
Function Storage_Unmount_Poll(storage_device, partition_number) As Long
  Storage_Unmount_Async_Start(storage_device, partition_number)
  Storage_Unmount_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_STORAGE_UNMOUNT)
EndFunction

'****************************************************************************
''' Start unmounting the filesystem on a partition on the SATA device connected to storage_device.
'''+
'''+Read return value with Storage_Async_Result.
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
'''****************************************************************************
Sub Storage_Unmount_Async_Start(storage_device, partition_number)
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DEVICE] = storage_device
  Data_200[EEPROM_SUPPORT_D200_STORAGE_PARTITION] = partition_number
  Data_200[EEPROM_SUPPORT_D200_STORAGE_LAST_COMMAND] = EEPROM_SUPPORT_STORAGE_UNMOUNT
  Par_95 = EEPROM_SUPPORT_STORAGE_UNMOUNT
  SEND_IRQ
EndSub
'<ENDREGION>

'<REGION> FS_STAT
#define STORAGE_FS_STAT_DATA_SIZE      100
#define STORAGE_FS_STAT_SIZE_LOW         1                  ' Low 32 bits of disk size in bytes
#define STORAGE_FS_STAT_SIZE_HIGH        2                  ' High 32 bits of disk size in bytes
#define STORAGE_FS_STAT_SIZE_MB          3                  ' disk size in MBytes (1024*1024 bytes)
#define STORAGE_FS_STAT_FREE_SPACE_LOW   4                  ' Low 32 bits of free disk space in bytes
#define STORAGE_FS_STAT_FREE_SPACE_HIGH  5                  ' High 32 bits of free disk space in bytes
#define STORAGE_FS_STAT_FREE_SPACE_MB    6                  ' free disk space in MBytes (1024*1024 bytes)
'****************************************************************************
''' Get filesystem status information, e.g. disk size and free disk space
'''+
'''+Returns EEPROM_SUPPORT_OK (0) on success, or a negative value on error 
'''+(see #Define EEPROM_SUPPORT_ERROR_* at the beginning of EEPROM_Support.inc)
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' result_data:  data number of data to fill with info, minimum size STORAGE_FS_STAT_DATA_SIZE
'''+         see STORAGE_FS_STAT_* indexes for details of the status data contents
''' result_offset: index to start writing at
'''****************************************************************************
Function Storage_FS_Stat_Poll(storage_device, partition_number, result_data, result_offset) As Long
  Storage_FS_Stat_Async_Start(storage_device, partition_number, result_data, result_offset)
  Storage_FS_Stat_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_STORAGE_FS_STAT)
EndFunction

'****************************************************************************
''' Start getting filesystem status information, e.g. disk size and free disk space
'''+
'''+Read return value with Storage_Async_Result.
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' result_data:  data number of data to fill with info, minimum size STORAGE_FS_STAT_DATA_SIZE
'''+         see STORAGE_FS_STAT_* indexes for details of the status data contents
''' result_offset: index to start writing at
'''****************************************************************************
Sub Storage_FS_Stat_Async_Start(storage_device, partition_number, result_data, result_offset)
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DEVICE] = storage_device
  Data_200[EEPROM_SUPPORT_D200_STORAGE_PARTITION] = partition_number
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DATA_NO] = result_data
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DATA_OFFSET] = result_offset
  Data_200[EEPROM_SUPPORT_D200_STORAGE_LAST_COMMAND] = EEPROM_SUPPORT_STORAGE_FS_STAT
  Par_95 = EEPROM_SUPPORT_STORAGE_FS_STAT
  SEND_IRQ
EndSub
'<ENDREGION>

'<REGION> File Create
'****************************************************************************
''' Creates an empty file. 
'''+
'''+Returns EEPROM_SUPPORT_OK (0) on success, or a negative value on error 
'''+(see #Define EEPROM_SUPPORT_ERROR_* at the beginning of EEPROM_Support.inc)
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' filename: data_number containing the file name (including full path)
''' file_infos: data number for additional information, currently unused, use 0
'''****************************************************************************
Function Storage_File_Create_Poll(storage_device, partition_number, filename, file_infos) As Long
  Storage_File_Create_Async_Start(storage_device, partition_number, filename, file_infos)
  Storage_File_Create_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_STORAGE_FILE_CREATE)
EndFunction

'****************************************************************************
''' Starts creating a file.
'''+
'''+Read return value with Storage_Async_Result.
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' filename: data_number containing the file name (including full path)
''' file_infos: data number for additional information, currently unused, use 0
'''****************************************************************************
Sub Storage_File_Create_Async_Start(storage_device, partition_number, filename, file_infos)
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DEVICE] = storage_device
  Data_200[EEPROM_SUPPORT_D200_STORAGE_PARTITION] = partition_number
  Data_200[EEPROM_SUPPORT_D200_STORAGE_FILENAME] = filename
  Data_200[EEPROM_SUPPORT_D200_STORAGE_INFOS] = file_infos
  Data_200[EEPROM_SUPPORT_D200_STORAGE_LAST_COMMAND] = EEPROM_SUPPORT_STORAGE_FILE_CREATE
  Par_95 = EEPROM_SUPPORT_STORAGE_FILE_CREATE
  SEND_IRQ
EndSub
'<ENDREGION>

'<REGION> File Delete
'****************************************************************************
''' Deletes a file. 
'''+
'''+Returns EEPROM_SUPPORT_OK (0) on success, or a negative value on error 
'''+(see #Define EEPROM_SUPPORT_ERROR_* at the beginning of EEPROM_Support.inc)
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' filename: data_number containing the file name (including full path)
'''****************************************************************************
Function Storage_File_Delete_Poll(storage_device, partition_number, filename) As Long
  Storage_File_Delete_Async_Start(storage_device, partition_number, filename)
  Storage_File_Delete_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_STORAGE_FILE_DELETE)
EndFunction

'****************************************************************************
''' Starts deleting a file.
'''+
'''+Read return value with Storage_Async_Result.
'''+Return value:    0 = Successfully completed.
'''+              -101 = Instruction is not completed yet.
'''+               < 0 = Error
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 0
''' filename: data_number containing the file name (including full path)
'''****************************************************************************
Sub Storage_File_Delete_Async_Start(storage_device, partition_number, filename)
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DEVICE] = storage_device
  Data_200[EEPROM_SUPPORT_D200_STORAGE_PARTITION] = partition_number
  Data_200[EEPROM_SUPPORT_D200_STORAGE_FILENAME] = filename
  Data_200[EEPROM_SUPPORT_D200_STORAGE_LAST_COMMAND] = EEPROM_SUPPORT_STORAGE_FILE_DELETE
  Par_95 = EEPROM_SUPPORT_STORAGE_FILE_DELETE
  SEND_IRQ
EndSub
'<ENDREGION>

'<REGION> File Exists
'****************************************************************************
''' Tests, if a file exists and writes to result
'''+
'''+Returns EEPROM_SUPPORT_OK (0) on success, or a negative value on error 
'''+(see #Define EEPROM_SUPPORT_ERROR_* at the beginning of EEPROM_Support.inc)
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' filename: data_number containing the file name (including full path)
''' result_data:   data number to write the result to
''' result_offset: index in result_data to write result to
'''****************************************************************************
Function Storage_File_Exists_Poll(storage_device, partition_number, filename, result_data, result_offset) As Long
  Storage_File_Exists_Async_Start(storage_device, partition_number, filename, result_data, result_offset)
  Storage_File_Exists_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_STORAGE_FILE_EXISTS)
EndFunction

'****************************************************************************
''' Starts checking if a file exists.
'''+
'''+Read return value with Storage_Async_Result.
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' filename: data_number containing the file name (including full path)
''' result_data:   data number to write the result to
''' result_offset: index in result_data to write result to
'''****************************************************************************
Sub Storage_File_Exists_Async_Start(storage_device, partition_number, filename, result_data, result_offset)
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DEVICE] = storage_device
  Data_200[EEPROM_SUPPORT_D200_STORAGE_PARTITION] = partition_number
  Data_200[EEPROM_SUPPORT_D200_STORAGE_FILENAME] = filename
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DATA_NO] = result_data
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DATA_OFFSET] = result_offset
  Data_200[EEPROM_SUPPORT_D200_STORAGE_LAST_COMMAND] = EEPROM_SUPPORT_STORAGE_FILE_EXISTS
  Par_95 = EEPROM_SUPPORT_STORAGE_FILE_EXISTS
  SEND_IRQ
EndSub
'<ENDREGION>

'<REGION> File Write
'****************************************************************************
''' Write into given file at specified position.
'''+
'''+Returns EEPROM_SUPPORT_OK (0) on success, or a negative value on error 
'''+(see #Define EEPROM_SUPPORT_ERROR_* at the beginning of EEPROM_Support.inc)
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' filename: data_number containing the file name (including full path)
''' file_offset: absolute offset in BYTES in destination file 
''' data_no:     Number n (1..199) of a global array Data_n, where values are read.
''' data_offset: Position (1..n) in the data_no, where reading starts (WORDS, not BYTES!).
''' count:       number of BYTES to be transferred (1 word = 4 bytes).
'''****************************************************************************
Function Storage_File_Write_Poll(storage_device, partition_number, filename, file_offset, data_no, data_offset, count) As Long
  Storage_File_Write_Async_Start(storage_device, partition_number, filename, file_offset, data_no, data_offset, count)
  Storage_File_Write_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_STORAGE_FILE_WRITE)
EndFunction

'****************************************************************************
''' Starts writing into a given file at specified position.
'''+
'''+Read return value with Storage_Async_Result.
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' filename: data_number containing the file name (including full path)
''' file_offset: absolute offset in BYTES in destination file 
''' data_no:     Number n (1..199) of a global array Data_n, where values are read.
''' data_offset: Position (1..n) in the data_no, where reading starts (WORDS, not BYTES!).
''' count:       number of BYTES to be transferred (1 word = 4 bytes).
'''****************************************************************************
Sub Storage_File_Write_Async_Start(storage_device, partition_number, filename, file_offset, data_no, data_offset, count)
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DEVICE] = storage_device
  Data_200[EEPROM_SUPPORT_D200_STORAGE_PARTITION] = partition_number
  Data_200[EEPROM_SUPPORT_D200_STORAGE_FILENAME] = filename
  Data_200[EEPROM_SUPPORT_D200_STORAGE_FILE_OFFSET] = file_offset
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DATA_NO] = data_no
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DATA_OFFSET] = data_offset
  Data_200[EEPROM_SUPPORT_D200_STORAGE_BYTECOUNT] = count
  Data_200[EEPROM_SUPPORT_D200_STORAGE_LAST_COMMAND] = EEPROM_SUPPORT_STORAGE_FILE_WRITE
  Par_95 = EEPROM_SUPPORT_STORAGE_FILE_WRITE
  SEND_IRQ
EndSub
'<ENDREGION>

'<REGION> File Read
'****************************************************************************
''' Read from file into data_no.
'''+
'''+Returns EEPROM_SUPPORT_OK (0) on success, or a negative value on error 
'''+(see #Define EEPROM_SUPPORT_ERROR_* at the beginning of EEPROM_Support.inc)
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' filename: data_number containing the file name (including full path)
''' file_offset: absolute offset in BYTES in source file 
''' data_no:     Number n (1..199) of a global array Data_n, where values are written to.
''' data_offset: Position (1..n) in the data_no, wher writing starts (WORDS, not BYTES!).
''' count:       number of BYTES to be transferred (1 word = 4 bytes).
'''****************************************************************************
Function Storage_File_Read_Poll(storage_device, partition_number, filename, file_offset, data_no, data_offset, count) As Long
  Storage_File_Read_Async_Start(storage_device, partition_number, filename, file_offset, data_no, data_offset, count)
  Storage_File_Read_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_STORAGE_FILE_READ)
EndFunction

'****************************************************************************
''' Starts reading from a file into data_no.
'''+
'''+Read return value with Storage_Async_Result.
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' filename: data_number containing the file name (including full path)
''' file_offset: absolute offset in BYTES in source file 
''' data_no:     Number n (1..199) of a global array Data_n, where values are written to.
''' data_offset: Position (1..n) in the data_no, wher writing starts (WORDS, not BYTES!).
''' count:       number of BYTES to be transferred (1 word = 4 bytes).
'''****************************************************************************
Sub Storage_File_Read_Async_Start(storage_device, partition_number, filename, file_offset, data_no, data_offset, count)
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DEVICE] = storage_device
  Data_200[EEPROM_SUPPORT_D200_STORAGE_PARTITION] = partition_number
  Data_200[EEPROM_SUPPORT_D200_STORAGE_FILENAME] = filename
  Data_200[EEPROM_SUPPORT_D200_STORAGE_FILE_OFFSET] = file_offset
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DATA_NO] = data_no
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DATA_OFFSET] = data_offset
  Data_200[EEPROM_SUPPORT_D200_STORAGE_BYTECOUNT] = count
  Data_200[EEPROM_SUPPORT_D200_STORAGE_LAST_COMMAND] = EEPROM_SUPPORT_STORAGE_FILE_READ
  Par_95 = EEPROM_SUPPORT_STORAGE_FILE_READ
  SEND_IRQ
EndSub
'<ENDREGION>

'<REGION> File Append
'****************************************************************************
''' Append to given file.
'''+
'''+Returns EEPROM_SUPPORT_OK (0) on success, or a negative value on error 
'''+(see #Define EEPROM_SUPPORT_ERROR_* at the beginning of EEPROM_Support.inc)
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' filename: data_number containing the file name (including full path)
''' data_no:     Number n (1..199) of a global array Data_n, where values are read.
''' data_offset: Position (1..n) in the data_no, where reading starts (WORDS, not BYTES!).
''' count:       number of BYTES to be transferred (1 word = 4 bytes).
'''****************************************************************************
Function Storage_File_Append_Poll(storage_device, partition_number, filename, data_no, data_offset, count) As Long
  Storage_File_Append_Async_Start(storage_device, partition_number, filename, data_no, data_offset, count)
  Storage_File_Append_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_STORAGE_FILE_APPEND)
EndFunction

'****************************************************************************
''' Starts appending to a given file.
'''+
'''+Read return value with Storage_Async_Result.
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' filename: data_number containing the file name (including full path)
''' file_offset: absolute offset in BYTES in destination file 
''' data_no:     Number n (1..199) of a global array Data_n, where values are read.
''' data_offset: Position (1..n) in the data_no, where reading starts (WORDS, not BYTES!).
''' count:       number of BYTES to be transferred (1 word = 4 bytes).
'''****************************************************************************
Sub Storage_File_Append_Async_Start(storage_device, partition_number, filename, data_no, data_offset, count)
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DEVICE] = storage_device
  Data_200[EEPROM_SUPPORT_D200_STORAGE_PARTITION] = partition_number
  Data_200[EEPROM_SUPPORT_D200_STORAGE_FILENAME] = filename
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DATA_NO] = data_no
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DATA_OFFSET] = data_offset
  Data_200[EEPROM_SUPPORT_D200_STORAGE_BYTECOUNT] = count
  Data_200[EEPROM_SUPPORT_D200_STORAGE_LAST_COMMAND] = EEPROM_SUPPORT_STORAGE_FILE_APPEND
  Par_95 = EEPROM_SUPPORT_STORAGE_FILE_APPEND
  SEND_IRQ
EndSub
'<ENDREGION>

'<REGION> File Stat
#define STORAGE_STAT_DATA_SIZE   100
#define STORAGE_STAT_SIZE_LOW      1 ''' low 32 bits of data size
#define STORAGE_STAT_SIZE_HIGH     2 ''' high 32 bits of data size
#define STORAGE_STAT_IS_FILE       3 ''' 1 if it is a regular file
#define STORAGE_STAT_IS_DIR        4 ''' 1 if it is a directory
'****************************************************************************
''' Get file status.
'''+
'''+Returns EEPROM_SUPPORT_OK (0) on success, or a negative value on error 
'''+(see #Define EEPROM_SUPPORT_ERROR_* at the beginning of EEPROM_Support.inc)
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' filename: data_number containing the file name (including full path)
''' result_data: data number of data to fill with info (TODO: Size?)
'''+         see STORAGE_STAT_* indexes for details of the status data contents
''' result_offset: offset in result_data to start writing at
'''****************************************************************************
Function Storage_File_Status_Poll(storage_device, partition_number, filename, result_data, result_offset) As Long
  Storage_File_Status_Async_Start(storage_device, partition_number, filename, result_data, result_offset)
  Storage_File_Status_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_STORAGE_FILE_STAT)
EndFunction

'****************************************************************************
''' Starts getting file status.
'''+
'''+Read return value with Storage_Async_Result.
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' filename: data_number containing the file name (including full path)
''' result_data: data number of data to fill with info (TODO: Size?)
'''+         see STORAGE_STAT_* indexes for details of the status data contents
''' result_offset: offset in result_data to start writing at
'''****************************************************************************
Sub Storage_File_Status_Async_Start(storage_device, partition_number, filename, result_data, result_offset))
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DEVICE] = storage_device
  Data_200[EEPROM_SUPPORT_D200_STORAGE_PARTITION] = partition_number
  Data_200[EEPROM_SUPPORT_D200_STORAGE_FILENAME] = filename
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DATA_NO] = result_data
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DATA_OFFSET] = result_offset
  Data_200[EEPROM_SUPPORT_D200_STORAGE_LAST_COMMAND] = EEPROM_SUPPORT_STORAGE_FILE_STAT
  Par_95 = EEPROM_SUPPORT_STORAGE_FILE_STAT
  SEND_IRQ
EndSub
'<ENDREGION>

'<REGION> File Move/Rename
'****************************************************************************
''' Rename or move a file.
'''+
'''+Returns EEPROM_SUPPORT_OK (0) on success, or a negative value on error 
'''+(see #Define EEPROM_SUPPORT_ERROR_* at the beginning of EEPROM_Support.inc)
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' filename_old: data_number containing the old file name (including full path)
''' filename_new: data_number containing the new file name (including full path)
'''****************************************************************************
Function Storage_File_Move_Poll(storage_device, partition_number, filename_old, filename_new) As Long
  Storage_File_Move_Async_Start(storage_device, partition_number, filename_old, filename_new)
  Storage_File_Move_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_STORAGE_FILE_MOVE)
EndFunction

'****************************************************************************
''' Start renaming or moving a file.
'''+
'''+Read return value with Storage_Async_Result.
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' filename_old: data_number containing the old file name (including full path)
''' filename_new: data_number containing the new file name (including full path)
'''****************************************************************************
Sub Storage_File_Move_Async_Start(storage_device, partition_number, filename_old, filename_new)
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DEVICE] = storage_device
  Data_200[EEPROM_SUPPORT_D200_STORAGE_PARTITION] = partition_number
  Data_200[EEPROM_SUPPORT_D200_STORAGE_FILENAME] = filename_old
  Data_200[EEPROM_SUPPORT_D200_STORAGE_INFOS] = filename_new
  Data_200[EEPROM_SUPPORT_D200_STORAGE_LAST_COMMAND] = EEPROM_SUPPORT_STORAGE_FILE_MOVE
  Par_95 = EEPROM_SUPPORT_STORAGE_FILE_MOVE
  SEND_IRQ
EndSub
'<ENDREGION>

'<REGION> File Copy
'****************************************************************************
''' Copy a file.
'''+
'''+Returns EEPROM_SUPPORT_OK (0) on success, or a negative value on error 
'''+(see #Define EEPROM_SUPPORT_ERROR_* at the beginning of EEPROM_Support.inc)
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' filename_old: data_number containing the old file name (including full path)
''' filename_new: data_number containing the new file name (including full path)
'''****************************************************************************
Function Storage_File_Copy_Poll(storage_device, partition_number, filename_old, filename_new) As Long
  Storage_File_Copy_Async_Start(storage_device, partition_number, filename_old, filename_new)
  Storage_File_Copy_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_STORAGE_FILE_COPY)
EndFunction

'****************************************************************************
''' Start copying a file.
'''+
'''+Read return value with Storage_Async_Result.
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' filename_old: data_number containing the old file name (including full path)
''' filename_new: data_number containing the new file name (including full path)
'''****************************************************************************
Sub Storage_File_Copy_Async_Start(storage_device, partition_number, filename_old, filename_new)
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DEVICE] = storage_device
  Data_200[EEPROM_SUPPORT_D200_STORAGE_PARTITION] = partition_number
  Data_200[EEPROM_SUPPORT_D200_STORAGE_FILENAME] = filename_old
  Data_200[EEPROM_SUPPORT_D200_STORAGE_INFOS] = filename_new
  Data_200[EEPROM_SUPPORT_D200_STORAGE_LAST_COMMAND] = EEPROM_SUPPORT_STORAGE_FILE_COPY
  Par_95 = EEPROM_SUPPORT_STORAGE_FILE_COPY
  SEND_IRQ
EndSub
'<ENDREGION>

'<REGION> Dir Create
'****************************************************************************
''' Create a directory.
'''+
'''+Returns EEPROM_SUPPORT_OK (0) on success, or a negative value on error 
'''+(see #Define EEPROM_SUPPORT_ERROR_* at the beginning of EEPROM_Support.inc)
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' dirname: data_number containing the directory to create (including full path)
'''****************************************************************************
Function Storage_Dir_Create_Poll(storage_device, partition_number, dirname) As Long
  Storage_Dir_Create_Async_Start(storage_device, partition_number, dirname)
  Storage_Dir_Create_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_STORAGE_DIR_CREATE)
EndFunction

'****************************************************************************
''' Start creating a directory
'''+
'''+Read return value with Storage_Async_Result.
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' dirname: data_number containing the directory to create (including full path)
'''****************************************************************************
Sub Storage_Dir_Create_Async_Start(storage_device, partition_number, dirname)
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DEVICE] = storage_device
  Data_200[EEPROM_SUPPORT_D200_STORAGE_PARTITION] = partition_number
  Data_200[EEPROM_SUPPORT_D200_STORAGE_FILENAME] = dirname
  Data_200[EEPROM_SUPPORT_D200_STORAGE_LAST_COMMAND] = EEPROM_SUPPORT_STORAGE_DIR_CREATE
  Par_95 = EEPROM_SUPPORT_STORAGE_DIR_CREATE
  SEND_IRQ
EndSub
'<ENDREGION>

'<REGION> Dir Delete
'****************************************************************************
''' Delete a directory (recursively).
'''+
'''+Returns EEPROM_SUPPORT_OK (0) on success, or a negative value on error 
'''+(see #Define EEPROM_SUPPORT_ERROR_* at the beginning of EEPROM_Support.inc)
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' dirname: data_number containing the directory to delete (including full path)
'''****************************************************************************
Function Storage_Dir_Delete_Poll(storage_device, partition_number, dirname) As Long
  Storage_Dir_Delete_Async_Start(storage_device, partition_number, dirname)
  Storage_Dir_Delete_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_STORAGE_DIR_DELETE)
EndFunction

'****************************************************************************
''' Start deleting a directory (recursively)
'''+
'''+Read return value with Storage_Async_Result.
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' dirname: data_number containing the directory to delete (including full path)
'''****************************************************************************
Sub Storage_Dir_Delete_Async_Start(storage_device, partition_number, dirname)
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DEVICE] = storage_device
  Data_200[EEPROM_SUPPORT_D200_STORAGE_PARTITION] = partition_number
  Data_200[EEPROM_SUPPORT_D200_STORAGE_FILENAME] = dirname
  Data_200[EEPROM_SUPPORT_D200_STORAGE_LAST_COMMAND] = EEPROM_SUPPORT_STORAGE_DIR_DELETE
  Par_95 = EEPROM_SUPPORT_STORAGE_DIR_DELETE
  SEND_IRQ
EndSub
'<ENDREGION>

'<REGION> Dir Exists
'****************************************************************************
''' Check if a directory exists.
'''+
'''+Returns EEPROM_SUPPORT_OK (0) on success, or a negative value on error 
'''+(see #Define EEPROM_SUPPORT_ERROR_* at the beginning of EEPROM_Support.inc)
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' dirname: data_number containing the directory to check (including full path)
''' result_data:   data number to write the result to
''' result_offset: index in result_data to write result to
'''****************************************************************************
Function Storage_Dir_Exists_Poll(storage_device, partition_number, dirname, result_data, result_offset) As Long
  Storage_Dir_Exists_Async_Start(storage_device, partition_number, dirname, result_data, result_offset)
  Storage_Dir_Exists_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_STORAGE_DIR_EXISTS)
EndFunction

'****************************************************************************
''' Start checking if a directory exists.
'''+
'''+Read return value with Storage_Async_Result.
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' dirname: data_number containing the directory to check (including full path)
''' result_data:   data number to write the result to
''' result_offset: index in result_data to write result to
'''****************************************************************************
Sub Storage_Dir_Exists_Async_Start(storage_device, partition_number, dirname, result_data, result_offset)
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DEVICE] = storage_device
  Data_200[EEPROM_SUPPORT_D200_STORAGE_PARTITION] = partition_number
  Data_200[EEPROM_SUPPORT_D200_STORAGE_FILENAME] = dirname
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DATA_NO] = result_data
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DATA_OFFSET] = result_offset
  Data_200[EEPROM_SUPPORT_D200_STORAGE_LAST_COMMAND] = EEPROM_SUPPORT_STORAGE_DIR_EXISTS
  Par_95 = EEPROM_SUPPORT_STORAGE_DIR_EXISTS
  SEND_IRQ
EndSub
'<ENDREGION>

'<REGION> Dir Exists
'****************************************************************************
''' Get info about directory.
'''+
'''+Returns EEPROM_SUPPORT_OK (0) on success, or a negative value on error 
'''+(see #Define EEPROM_SUPPORT_ERROR_* at the beginning of EEPROM_Support.inc)
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' dirname: data_number containing the directory to check (including full path)
''' status:  data number of data to fill with info (TODO: Size?)
'''****************************************************************************
Function Storage_Dir_Status_Poll(storage_device, partition_number, dirname, status) As Long
  Storage_Dir_Status_Async_Start(storage_device, partition_number, dirname, status)
  Storage_Dir_Status_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_STORAGE_DIR_STAT)
EndFunction

'****************************************************************************
''' Start getting directory information.
'''+
'''+Read return value with Storage_Async_Result.
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' dirname: data_number containing the directory to check (including full path)
''' status:  data number of data to fill with info (TODO: Size?)
'''****************************************************************************
Sub Storage_Dir_Status_Async_Start(storage_device, partition_number, dirname, status)
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DEVICE] = storage_device
  Data_200[EEPROM_SUPPORT_D200_STORAGE_PARTITION] = partition_number
  Data_200[EEPROM_SUPPORT_D200_STORAGE_FILENAME] = dirname
  Data_200[EEPROM_SUPPORT_D200_STORAGE_INFOS] = status
  Data_200[EEPROM_SUPPORT_D200_STORAGE_LAST_COMMAND] = EEPROM_SUPPORT_STORAGE_DIR_STAT
  Par_95 = EEPROM_SUPPORT_STORAGE_DIR_STAT
  SEND_IRQ
EndSub
'<ENDREGION>

'<REGION> Dir size
#define STORAGE_DIR_SIZE_DATA_SIZE      100
#define STORAGE_DIR_SIZE_LOW         1                      ' Low 32 bits of dir size in bytes
#define STORAGE_DIR_SIZE_HIGH        2                      ' High 32 bits of dir size in bytes
#define STORAGE_DIR_SIZE_MB          3                      ' dir size in MBytes (1024*1024 bytes)
#define STORAGE_DIR_SIZE_USAGE_LOW   4                      ' Low 32 bits of occupied space of dir in bytes
#define STORAGE_DIR_SIZE_USAGE_HIGH  5                      ' High 32 bits of occupied space of dir in bytes
#define STORAGE_DIR_SIZE_USAGE_MB    6                      ' occupied space of dir in MBytes (1024*1024 bytes)
'****************************************************************************
''' Get dir size recursively.
'''+
'''+Returns EEPROM_SUPPORT_OK (0) on success, or a negative value on error 
'''+(see #Define EEPROM_SUPPORT_ERROR_* at the beginning of EEPROM_Support.inc)
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' dirname: data_number containing the directory to check (including full path)
''' result_data:  data number of data to fill with info, minimum size STORAGE_DIR_SIZE_DATA_SIZE
'''+         see STORAGE_DIR_SIZE_* indexes for details of the status data contents
''' result_offset: index to start writing at
'''****************************************************************************
Function Storage_Dir_Size_Poll(storage_device, partition_number, dirname, result_data, result_offset) As Long
  Storage_Dir_Size_Async_Start(storage_device, partition_number, dirname, result_data, result_offset)
  Storage_Dir_Size_Poll = EEPROM_Poll_Result(EEPROM_SUPPORT_STORAGE_DIR_SIZE)
EndFunction

'****************************************************************************
''' Start getting dir size recursively.
'''+
'''+Read return value with Storage_Async_Result.
''' storage_device: 0: SATA0
'''+                1: SATA1
'''+                100h: USB
''' partition_number: currently only one partition is supported, use 1
''' dirname: data_number containing the directory to check (including full path)
''' result_data:  data number of data to fill with info, minimum size STORAGE_DIR_SIZE_DATA_SIZE
'''+         see STORAGE_DIR_SIZE_* indexes for details of the status data contents
''' result_offset: index to start writing at
'''****************************************************************************
Sub Storage_Dir_Size_Async_Start(storage_device, partition_number, dirname, result_data, result_offset)
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DEVICE] = storage_device
  Data_200[EEPROM_SUPPORT_D200_STORAGE_PARTITION] = partition_number
  Data_200[EEPROM_SUPPORT_D200_STORAGE_FILENAME] = dirname
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DATA_NO] = result_data
  Data_200[EEPROM_SUPPORT_D200_STORAGE_DATA_OFFSET] = result_offset
  Data_200[EEPROM_SUPPORT_D200_STORAGE_LAST_COMMAND] = EEPROM_SUPPORT_STORAGE_DIR_SIZE
  Par_95 = EEPROM_SUPPORT_STORAGE_DIR_SIZE
  SEND_IRQ
EndSub
'<ENDREGION>

'****************************************************************************
''' Returns the status of the previously used asynchronous SATA instruction.
'''+Return value:
'''+         0 = EEPROM_SUPPORT_OK: no error
'''+        -1 = EEPROM_SUPPORT_ERROR_UNKNOWN_COMMAND:  Unknown command
'''+        -5 = EEPROM_SUPPORT_ERROR_DATA_200_ACCESS_ERROR: Problem accessing DATA_200
'''+        -6 = EEPROM_SUPPORT_ERROR_DATA_ACCESS_ERROR: Problem accessing a DATA-Array
'''+      -100 = EEPROM_SUPPORT_ERROR_TIMEOUT: A timeout occurred while waiting for the command to finish
'''+      -101 = EEPROM_SUPPORT_ERROR_NOT_READY: The previous command is not yet completed.
'''+      -100000 = EEPROM_SUPPORT_ERROR_STORAGE_GENERAL_ERROR: A generic error ocurred, for details Jger Messtechnik
'''+      -100001 = EEPROM_SUPPORT_ERROR_STORAGE_INVALID_DEVICE_ID
'''+      -100002 = EEPROM_SUPPORT_ERROR_STORAGE_NO_SUCH_FILE_OR_DIRECTORY
'''+      -100003 = EEPROM_SUPPORT_ERROR_STORAGE_ERROR_WRITING_TO_DISK
'''+      -100004 = EEPROM_SUPPORT_ERROR_STORAGE_ERROR_READING_FROM_DISK
'''+      -100005 = EEPROM_SUPPORT_ERROR_STORAGE_ERROR_COULD_NOT_DELETE_FILE
'''+      -100006 = EEPROM_SUPPORT_ERROR_STORAGE_NOT_MOUNTED
'''+      -100007 = EEPROM_SUPPORT_ERROR_STORAGE_ALREADY_MOUNTED
'''+      -100008 = EEPROM_SUPPORT_ERROR_STORAGE_ERROR_RENAMING_FILE
'''+      -100009 = EEPROM_SUPPORT_ERROR_STORAGE_COULD_NOT_CREATE_FILE
'''+      -100010 = EEPROM_SUPPORT_ERROR_STORAGE_COULD_NOT_DELETE_FILE
'''+      -100011 = EEPROM_SUPPORT_ERROR_STORAGE_INVALID_FILESYSTEM_ID
'''+      -500000 = EEPROM_SUPPORT_ERROR_STORAGE_ADWIN_COMMUNICATION_ERROR: A problem occurred while communicating with the ADwin system
Function Storage_Async_Result() As Long
  Storage_Async_Result = EEPROM_Async_Result()
EndFunction
'<ENDREGION>

'<REGION> Dir Move/Rename
'****************************************************************************
'''Rename or move a directory. This function just calls 
'''+Storage_File_Move_Poll, see that function for details.
'''****************************************************************************
Function Storage_Dir_Move_Poll(storage_device, partition_number, filename_old, filename_new) As Long
  Storage_Dir_Move_Poll = Storage_File_Move_Poll(storage_device, partition_number, filename_old, filename_new)
EndFunction

'****************************************************************************
''' Start renaming or moving a directory. This function just calls 
'''+Storage_File_Move_Async_Start, see that function for details.
'''****************************************************************************
Sub Storage_Dir_Move_Async_Start(storage_device, partition_number, filename_old, filename_new)
  Storage_File_Move_Async_Start(storage_device, partition_number, filename_old, filename_new)
EndSub
'<ENDREGION>

'<REGION> Dir Copy
'****************************************************************************
'''Copy a directory (recursively). This function just calls 
'''+Storage_File_Copy_Poll, see that function for details.
'''****************************************************************************
Function Storage_Dir_Copy_Poll(storage_device, partition_number, filename_old, filename_new) As Long
  Storage_Dir_Copy_Poll = Storage_File_Copy_Poll(storage_device, partition_number, filename_old, filename_new)
EndFunction

'****************************************************************************
''' Start copying a directory (recursively). This function just calls 
'''+Storage_File_Copy_Async_Start, see that function for details.
'''****************************************************************************
Sub Storage_Dir_Copy_Async_Start(storage_device, partition_number, filename_old, filename_new)
  Storage_File_Copy_Async_Start(storage_device, partition_number, filename_old, filename_new)
EndSub
'<ENDREGION>

